/*204:*/
#line 7815 "annoyance-filter.w"

#define REVDATE "2002-10-22"
#define Xfile string("X-Annoyance-Filter")  \
 \

#define pseudoCountsWord " COUNTS " \

#define messageSentinel "From " \

#define ChIx(c) (static_cast<unsigned int> ((c) ) &0xFF)  \

#define HTMLCommentBegin "<!--"
#define HTMLCommentEnd "-->" \

#define Annotate(c) (annotations.test(c) )  \


#line 7816 "annoyance-filter.w"


/*186:*/
#line 7141 "annoyance-filter.w"

#include "config.h"      

/*191:*/
#line 7244 "annoyance-filter.w"

#ifdef WIN32
#undef HAVE_MMAP
#undef HAVE_POPEN
#undef HAVE_DIRENT_H
#endif


/*:191*/
#line 7144 "annoyance-filter.w"


/*187:*/
#line 7164 "annoyance-filter.w"

#include <iostream> 
#include <iomanip> 
#include <fstream> 
#include <cstdlib> 
#include <string> 
#include <sstream> 
#include <vector> 
#include <algorithm> 
#include <map> 
#include <stack> 
#include <deque> 
#include <queue> 
#include <list> 
#include <set> 
#include <bitset> 
#include <functional> 
using namespace std;

/*:187*/
#line 7146 "annoyance-filter.w"

/*188:*/
#line 7187 "annoyance-filter.w"

#include <stdio.h> 
#include <stdlib.h> 
#include <fcntl.h> 
#include <ctype.h> 
#include <string.h> 

/*:188*/
#line 7147 "annoyance-filter.w"

/*189:*/
#line 7200 "annoyance-filter.w"

#ifdef HAVE_STAT
#include <sys/stat.h> 
#endif
#ifdef HAVE_UNISTD_H
#include <unistd.h> 
#endif
#ifdef HAVE_DIRENT_H
#include <dirent.h> 
#endif
#ifdef HAVE_MMAP
#include <sys/mman.h> 
#include "mystrstream.h"
#endif

/*:189*/
#line 7148 "annoyance-filter.w"


#include "getopt.h"     
#include "statlib.h" 

/*190:*/
#line 7222 "annoyance-filter.w"

#if defined(HAVE_GNUPLOT) && defined(HAVE_NETPBM) && defined(HAVE_SYSTEM)
#define HAVE_PLOT_UTILITIES
#endif

#if defined(HAVE_DIRENT_H) && defined(HAVE_STAT)
#define HAVE_DIRECTORY_TRAVERSAL
#endif

#if defined(HAVE_PDFTOTEXT) && defined(HAVE_POPEN) && (defined(HAVE_MKSTEMP) || defined(HAVE_TMPNAM))
#define HAVE_PDF_DECODER
#endif

/*:190*/
#line 7153 "annoyance-filter.w"


/*:186*/
#line 7818 "annoyance-filter.w"

/*181:*/
#line 7032 "annoyance-filter.w"

static unsigned int messageCount[2];
static list<string> messageTranscript;
static queue<string> parserDiagnostics;
static bool saveParserDiagnostics= false;


/*:181*//*194:*/
#line 7279 "annoyance-filter.w"

static bool verbose= false;
#ifdef TYPE_LOG
static ofstream typeLog("/tmp/typelog.txt");
#endif
static string pDiagFilename= "";
static string transcriptFilename= "";
static bool pTokenTrace= false;
static unsigned int maxTokenLength= 64,minTokenLength= 1;
static unsigned int streamMaxTokenLength= 64,streamMinTokenLength= 5;
static bool singleDictionaryRead= true;
static unsigned int phraseMin= 1,phraseMax= 1;
static unsigned int phraseLimit= 0;

/*:194*//*200:*/
#line 7749 "annoyance-filter.w"


#define ISOch(x)     (static_cast<unsigned char> ((x) & 0xFF))
#define isISOspace(x)   (isascii(ISOch(x)) && isspace(ISOch(x)))
#define isISOalpha(x)   ((isoalpha[ISOch(x) / 8] & (0x80 >> (ISOch(x) % 8))) != 0)
#define isISOupper(x)   ((isoupper[ISOch(x) / 8] & (0x80 >> (ISOch(x) % 8))) != 0)
#define isISOlower(x)   ((isolower[ISOch(x) / 8] & (0x80 >> (ISOch(x) % 8))) != 0)
#define toISOupper(x)   (isISOlower(x) ? (isascii(((unsigned char) (x))) ?  \
                            toupper(x) : (((ISOch(x) != 0xDF) && \
                            (ISOch(x) != 0xFF)) ? \
                            (ISOch(x) - 0x20) : (x))) : (x))
#define toISOlower(x)   (isISOupper(x) ? (isascii(ISOch(x)) ?  \
                            tolower(x) : (ISOch(x) + 0x20)) \
                            : (x))

/*:200*//*201:*/
#line 7768 "annoyance-filter.w"

const unsigned char isoalpha[32]= {
0,0,0,0,0,0,0,0,127,255,255,224,127,255,255,224,0,0,0,0,0,0,0,0,255,255,
254,255,255,255,254,255
};

const unsigned char isoupper[32]= {
0,0,0,0,0,0,0,0,127,255,255,224,0,0,0,0,0,0,0,0,0,0,0,0,255,255,254,254,
0,0,0,0
};

const unsigned char isolower[32]= {
0,0,0,0,0,0,0,0,0,0,0,0,127,255,255,224,0,0,0,0,0,0,0,0,0,0,0,1,255,255,
254,255
};

/*:201*/
#line 7819 "annoyance-filter.w"

/*8:*/
#line 1083 "annoyance-filter.w"

class dictionaryWord{
public:
static const unsigned int nCategories= 2;
enum mailCategory{Mail= 0,Junk= 1,Unknown};

string text;
unsigned int occurrences[nCategories];
double junkProbability;

dictionaryWord(string s= ""){
set(s);
}

void set(string s= "",unsigned int s_Mail= 0,unsigned int s_Junk= 0,
double jProb= -1){
text= s;
occurrences[Mail]= s_Mail;
occurrences[Junk]= s_Junk;
junkProbability= jProb;
}

string get(void)const{
return text;
}

unsigned int n_mail(void)const{
return occurrences[Mail];
}

unsigned int n_junk(void)const{
return occurrences[Junk];
}

void add(mailCategory cat,unsigned int howMany= 1){
assert(cat==Mail||cat==Junk);
occurrences[cat]+= howMany;
}





unsigned int resetCat(mailCategory cat){
assert(cat==Mail||cat==Junk);
occurrences[cat]= 0;
return occurrences[Mail]+occurrences[Junk];
}

void computeJunkProbability(unsigned int nMailMessages,unsigned int nJunkMessages,
double mailBias= 2,unsigned int minOccurrences= 5);

double getJunkProbability(void)const{
return junkProbability;
}

unsigned int length(void)const{
return text.length();
}

void toLower(void){
transform(text.begin(),text.end(),text.begin(),&dictionaryWord::to_iso_lower);
}

void describe(ostream&os= cout);

void exportCSV(ostream&os= cout);
bool importCSV(istream&is= cin);

static string categoryName(mailCategory c){
return(c==Mail)?"mail":((c==Junk)?"junk":"unknown");
}

void exportToBinaryFile(ostream&os);
bool importFromBinaryFile(istream&is);

protected:

/*16:*/
#line 1401 "annoyance-filter.w"


static char to_iso_lower(char c){
return toISOlower(c);
}

static char to_iso_upper(char c){
return toISOupper(c);
}

/*:16*/
#line 1161 "annoyance-filter.w"
;
};

/*:8*//*17:*/
#line 1421 "annoyance-filter.w"

class dictionary:public map<string,dictionaryWord> {
public:

void add(dictionaryWord w,dictionaryWord::mailCategory category);

void include(dictionaryWord&w);

void exportCSV(ostream&os= cout);
void importCSV(istream&is= cin);

void computeJunkProbability(unsigned int nMailMessages,unsigned int nJunkMessages,
double mailBias= 2,unsigned int minOccurrences= 5);

void purge(void);

void resetCat(dictionaryWord::mailCategory category);

void printStatistics(ostream&os= cout)const;

#ifdef HAVE_PLOT_UTILITIES
void plotProbabilityHistogram(string fileName,unsigned int nBins= 20)const;
#endif

void exportToBinaryFile(ostream&os);
void importFromBinaryFile(istream&is);
};

/*:17*//*30:*/
#line 1839 "annoyance-filter.w"

class mailFolder;

class MIMEdecoder{
public:
istream*is;
string partBoundary;
bool atEnd;
bool eofHit;
unsigned int nDecodeErrors;
protected:
string inputLine;
string::size_type ip;
unsigned encodedLineCount;
bool lookAhead;
int lookChar;
string endBoundary;
list<string> *tlist;
mailFolder*mf;

public:
MIMEdecoder(istream*i= NULL,mailFolder*m= NULL,string pb= "",list<string> *tl= NULL){
set(i,m,pb,tl);
resetDecodeErrors();
tlist= NULL;
}

virtual~MIMEdecoder(){
};

void set(istream*i= NULL,mailFolder*m= NULL,
string pb= "",list<string> *tl= NULL){
is= i;
mf= m;
partBoundary= pb;
inputLine= "";
ip= 0;
encodedLineCount= 0;
lookAhead= false;
atEnd= false;
eofHit= false;
tlist= tl;
}

virtual string name(void)const= 0;

virtual void resetDecodeErrors(void){
nDecodeErrors= 0;
}

virtual unsigned int getDecodeErrors(void)const{
return nDecodeErrors;
}

virtual string getTerminatorSentinel(void)const{
return endBoundary;
}

virtual bool isEndOfFile(void)const{
return eofHit;
}

virtual unsigned int getEncodedLineCount(void)const{
return encodedLineCount;
}

virtual int getDecodedChar(void)= 0;

virtual bool getDecodedLine(string&s);

virtual void saveDecodedStream(ostream&os);
virtual void saveDecodedStream(const string fname);

protected:
virtual bool getNextEncodedLine(void);
};

/*:30*//*36:*/
#line 2061 "annoyance-filter.w"

class identityMIMEdecoder:public MIMEdecoder{
public:
string name(void)const{
return"Identity";
}

int getDecodedChar(void){
while(!atEnd){
if(ip<inputLine.length()){
return inputLine[ip++]&0xFF;
}
if(getNextEncodedLine()){
continue;
}
}
return-1;
}

bool getDecodedLine(string&s){
if(ip<inputLine.length()){
s= inputLine.substr(ip);
ip= inputLine.length();
return true;
}
if(getNextEncodedLine()){
s= inputLine;
ip= inputLine.length();
return true;
}
return false;
}
};

/*:36*//*37:*/
#line 2102 "annoyance-filter.w"

class sinkMIMEdecoder:public MIMEdecoder{
public:
string name(void)const{
return"Sink";
}

int getDecodedChar(void){
if(!atEnd){
while(getNextEncodedLine());
assert(atEnd);
}
return-1;
}
};

/*:37*//*38:*/
#line 2125 "annoyance-filter.w"

class base64MIMEdecoder:public MIMEdecoder{
private:
unsigned char dtable[256];
void initialiseDecodingTable(void);
deque<unsigned char> decodedBytes;

public:
base64MIMEdecoder(){
initialiseDecodingTable();
}

string name(void)const{
return"Base64";
}

int getDecodedChar(void);

static string decodeEscapedText(const string s,mailFolder*m= NULL);

};

/*:38*//*48:*/
#line 2368 "annoyance-filter.w"

class quotedPrintableMIMEdecoder:public MIMEdecoder{
public:
quotedPrintableMIMEdecoder(){
atEndOfLine= false;
}

string name(void)const{
return"Quoted-Printable";
}

int getDecodedChar(void);

static string decodeEscapedText(const string s,mailFolder*m= NULL);

protected:
bool atEndOfLine;
int getNextChar(void);
static int hex_to_nybble(const int ch);
};

/*:48*//*58:*/
#line 2627 "annoyance-filter.w"

class MBCSdecoder{
protected:
const string*src;
string::size_type p;

public:
virtual string name(void)= 0;

virtual void setSource(const string&s){
src= &s;
p= 0;
}

virtual void reset(void){
}

virtual int getNextDecodedChar(void)= 0;

virtual int getNextEncodedByte(void){
if(p>=src->length()){
return-1;
}
return((*src)[p++])&0xFF;
}

protected:
virtual int getNextNBytes(const unsigned int n);

virtual int getNext2Bytes(void){
return getNextNBytes(2);
}

virtual int getNext3Bytes(void){
return getNextNBytes(3);
}

virtual int getNext4Bytes(void){
return getNextNBytes(4);
}

virtual void discardLine(void){
p= src->length();
}
};

/*:58*//*60:*/
#line 2706 "annoyance-filter.w"

class EUC_MBCSdecoder:public MBCSdecoder{
public:
virtual string name(void){
return"EUC";
}

virtual int getNextDecodedChar(void);
};

/*:60*//*62:*/
#line 2765 "annoyance-filter.w"

class Big5_MBCSdecoder:public MBCSdecoder{
public:
virtual string name(void){
return"Big5";
}

virtual int getNextDecodedChar(void);
};

/*:62*//*64:*/
#line 2810 "annoyance-filter.w"

class Shift_JIS_MBCSdecoder:public MBCSdecoder{
protected:
string pending;

public:
Shift_JIS_MBCSdecoder():pending(""){
}

virtual~Shift_JIS_MBCSdecoder(){
}

virtual string name(void){
return"Shift_JIS";
}

virtual int getNextDecodedChar(void);
};

/*:64*//*69:*/
#line 2931 "annoyance-filter.w"

class Unicode_MBCSdecoder:public MBCSdecoder{
public:
virtual string name(void){
return"Unicode";
}

virtual int getNextDecodedChar(void)= 0;
};

/*:69*//*70:*/
#line 2949 "annoyance-filter.w"

class UCS_2_Unicode_MBCSdecoder:public Unicode_MBCSdecoder{
protected:
bool bigEndian;

public:
UCS_2_Unicode_MBCSdecoder(bool isBigEndian= true){
setBigEndian(isBigEndian);
}

void setBigEndian(bool isBigEndian= true){
bigEndian= isBigEndian;
}

virtual string name(void){
return"UCS_2_Unicode";
}

virtual int getNextDecodedChar(void);
};

/*:70*//*72:*/
#line 2999 "annoyance-filter.w"

class UTF_8_Unicode_MBCSdecoder:public Unicode_MBCSdecoder{
public:
virtual string name(void){
return"UTF_8_Unicode";
}

virtual int getNextDecodedChar(void);
};

/*:72*//*74:*/
#line 3077 "annoyance-filter.w"

class UTF_16_Unicode_MBCSdecoder:public Unicode_MBCSdecoder{
protected:
bool bigEndian;

int getNextUTF_16Word(void){
int c1= getNextEncodedByte();
if(c1<0){
return c1;
}
int c2= getNextEncodedByte();
if(c2<0){
if(verbose){
cerr<<name()<<"_MBCSdecoder: Premature end of line in UTF-16 character."<<endl;
}
return-1;
}
if(bigEndian){
c1= (c1<<8)|c2;
}else{
c1|= (c2<<8);
}
return c1;
}

public:
UTF_16_Unicode_MBCSdecoder(bool isBigEndian= true){
setBigEndian(isBigEndian);
}

void setBigEndian(bool isBigEndian= true){
bigEndian= isBigEndian;
}

virtual string name(void){
return"UTF_16_Unicode";
}

virtual int getNextDecodedChar(void);
};

/*:74*//*77:*/
#line 3168 "annoyance-filter.w"

class MBCSinterpreter{
protected:
const string*src;
MBCSdecoder*dp;
string prefix,suffix;

public:

virtual~MBCSinterpreter(){
}

virtual string name(void)= 0;

virtual void setDecoder(MBCSdecoder&d){
dp= &d;
}

virtual void setSource(const string&s){
assert(dp!=NULL);
dp->setSource(s);
}

virtual void setPrefixSuffix(string pre= "",string suf= ""){
prefix= pre;
suffix= suf;
}

virtual string getNextDecodedChar(void);

virtual string decodeLine(const string&s);
};

/*:77*//*80:*/
#line 3254 "annoyance-filter.w"

class GB2312_MBCSinterpreter:public MBCSinterpreter{
public:
GB2312_MBCSinterpreter(){
setPrefixSuffix(" "," ");
}

virtual string name(void){
return"GB2312";
}
};

/*:80*//*81:*/
#line 3271 "annoyance-filter.w"

class Big5_MBCSinterpreter:public MBCSinterpreter{
public:
Big5_MBCSinterpreter(){
setPrefixSuffix(" "," ");
}

virtual string name(void){
return"Big5";
}
};

/*:81*//*82:*/
#line 3288 "annoyance-filter.w"

class Shift_JIS_MBCSinterpreter:public MBCSinterpreter{
public:
Shift_JIS_MBCSinterpreter(){
setPrefixSuffix(" "," ");
}

virtual string name(void){
return"Shift_JIS";
}

string getNextDecodedChar(void);
};

/*:82*//*84:*/
#line 3338 "annoyance-filter.w"

class KR_MBCSinterpreter:public MBCSinterpreter{
public:
virtual string name(void){
return"KR";
}
};

/*:84*//*85:*/
#line 3351 "annoyance-filter.w"

class Unicode_MBCSinterpreter:public MBCSinterpreter{
public:
Unicode_MBCSinterpreter(){
setPrefixSuffix(" "," ");
}

virtual string name(void){
return"Unicode";
}

string getNextDecodedChar(void);
};

/*:85*//*87:*/
#line 3421 "annoyance-filter.w"

class applicationStringParser{

protected:
bool error,eof;
mailFolder*mf;

virtual unsigned char get8(void);

virtual void get8n(unsigned char*buf,const int n){
for(int i= 0;(!eof)&&(i<n);i++){
buf[i]= get8();
}
}

public:
applicationStringParser(mailFolder*f= NULL):
error(false),eof(false),mf(NULL){
setMailFolder(f);
}

virtual~applicationStringParser(){
}

virtual string name(void)const= 0;

void setMailFolder(mailFolder*f){
mf= f;
}

virtual bool nextString(string&s)= 0;

virtual void close(void){
}

bool isError(void)const{
return error;
}

bool isEOF(void)const{
return eof;
}

bool isOK(void)const{
return(!isEOF())&&(!isError());
}
};

/*:87*//*89:*/
#line 3493 "annoyance-filter.w"

class flashStream:public applicationStringParser{
protected:

/*99:*/
#line 3833 "annoyance-filter.w"


typedef enum{
stagEnd= 0,
stagShowFrame= 1,
stagDefineShape= 2,
stagFreeCharacter= 3,
stagPlaceObject= 4,
stagRemoveObject= 5,
stagDefineBits= 6,
stagDefineButton= 7,
stagJPEGTables= 8,
stagSetBackgroundColor= 9,
stagDefineFont= 10,
stagDefineText= 11,
stagDoAction= 12,
stagDefineFontInfo= 13,
stagDefineSound= 14,
stagStartSound= 15,
stagDefineButtonSound= 17,
stagSoundStreamHead= 18,
stagSoundStreamBlock= 19,
stagDefineBitsLossless= 20,
stagDefineBitsJPEG2= 21,
stagDefineShape2= 22,
stagDefineButtonCxform= 23,
stagProtect= 24,


stagPlaceObject2= 26,
stagRemoveObject2= 28,
stagDefineShape3= 32,
stagDefineText2= 33,
stagDefineButton2= 34,
stagDefineBitsJPEG3= 35,
stagDefineBitsLossless2= 36,
stagDefineEditText= 37,
stagDefineSprite= 39,
stagNameCharacter= 40,
stagFrameLabel= 43,
stagSoundStreamHead2= 45,
stagDefineMorphShape= 46,
stagDefineFont2= 48,
}tagType;

/*:99*/
#line 3497 "annoyance-filter.w"
;
/*100:*/
#line 3887 "annoyance-filter.w"

typedef enum{
sactionNone= 0x00,
sactionNextFrame= 0x04,
sactionPrevFrame= 0x05,
sactionPlay= 0x06,
sactionStop= 0x07,
sactionToggleQuality= 0x08,
sactionStopSounds= 0x09,
sactionAdd= 0x0A,
sactionSubtract= 0x0B,
sactionMultiply= 0x0C,
sactionDivide= 0x0D,
sactionEqual= 0x0E,
sactionLessThan= 0x0F,
sactionLogicalAnd= 0x10,
sactionLogicalOr= 0x11,
sactionLogicalNot= 0x12,
sactionStringEqual= 0x13,
sactionStringLength= 0x14,
sactionSubString= 0x15,
sactionInt= 0x18,
sactionEval= 0x1C,
sactionSetVariable= 0x1D,
sactionSetTargetExpression= 0x20,
sactionStringConcat= 0x21,
sactionGetProperty= 0x22,
sactionSetProperty= 0x23,
sactionDuplicateClip= 0x24,
sactionRemoveClip= 0x25,
sactionTrace= 0x26,
sactionStartDragMovie= 0x27,
sactionStopDragMovie= 0x28,
sactionStringLessThan= 0x29,
sactionRandom= 0x30,
sactionMBLength= 0x31,
sactionOrd= 0x32,
sactionChr= 0x33,
sactionGetTimer= 0x34,
sactionMBSubString= 0x35,
sactionMBOrd= 0x36,
sactionMBChr= 0x37,
sactionHasLength= 0x80,
sactionGotoFrame= 0x81,
sactionGetURL= 0x83,
sactionWaitForFrame= 0x8A,

sactionSetTarget= 0x8B,
sactionGotoLabel= 0x8C,
sactionWaitForFrameExpression= 0x8D,

sactionPushData= 0x96,
sactionBranchAlways= 0x99,
sactionGetURL2= 0x9A,
sactionBranchIfTrue= 0x9D,
sactionCallFrame= 0x9E,
sactionGotoExpression= 0x9F
}actionCode;

/*:100*/
#line 3498 "annoyance-filter.w"
;
/*101:*/
#line 3951 "annoyance-filter.w"

typedef enum{
fontUnicode= 0x20,
fontShiftJIS= 0x10,
fontANSI= 0x08,
fontItalic= 0x04,
fontBold= 0x02,
fontWideCodes= 0x01
}fontFlags;

typedef enum{
isTextControl= 0x80,

textHasFont= 0x08,
textHasColor= 0x04,
textHasYOffset= 0x02,
textHasXOffset= 0x01
}textFlags;

typedef enum{
seditTextFlagsHasFont= 0x0001,
seditTextFlagsHasMaxLength= 0x0002,
seditTextFlagsHasTextColor= 0x0004,
seditTextFlagsReadOnly= 0x0008,
seditTextFlagsPassword= 0x0010,
seditTextFlagsMultiline= 0x0020,
seditTextFlagsWordWrap= 0x0040,
seditTextFlagsHasText= 0x0080,
seditTextFlagsUseOutlines= 0x0100,
seditTextFlagsBorder= 0x0800,
seditTextFlagsNoSelect= 0x1000,
seditTextFlagsHasLayout= 0x2000
}editTextFlags;

/*:101*/
#line 3499 "annoyance-filter.w"
;
/*102:*/
#line 3992 "annoyance-filter.w"

typedef struct{
int xMin,xMax,yMin,yMax;
}rect;

typedef struct{
int a;
int b;
int c;
int d;
int tx;
int ty;
}matrix;

/*:102*/
#line 3500 "annoyance-filter.w"
;



unsigned char sig[3];
unsigned char version;
unsigned int fileLength;
rect frameSize;
unsigned short frameRate;
unsigned short frameCount;



tagType tType;
unsigned int tDataLen;



unsigned int bitBuf,bitPos;

public:

flashStream(mailFolder*f= NULL):
applicationStringParser(f){
}

void readHeader(void);
void describe(ostream&os= cout);
bool nextTag(void);



tagType getTagType(void)const{
return tType;
}

unsigned int getTagDataLength(void)const{
return tDataLen;
}

void ignoreTag(unsigned int lookedAhead= 0);

protected:

/*97:*/
#line 3743 "annoyance-filter.w"

unsigned short get16(void){
unsigned short u16;

u16= get8();
u16|= get8()<<8;
return u16;
}

unsigned int get32(void){
unsigned int u32;

u32= get8();
u32|= get8()<<8;
u32|= get8()<<16;
u32|= get8()<<24;
return u32;
}

void get16n(unsigned short*buf,const int n){
for(int i= 0;(!eof)&&(i<n);i++){
buf[i]= get16();
}
}

void get32n(unsigned int*buf,const int n){
for(int i= 0;(!eof)&&(i<n);i++){
buf[i]= get32();
}
}

/*:97*/
#line 3544 "annoyance-filter.w"
;


void skip8n(const int n){
for(int i= 0;(!eof)&&(i<n);i++){
get8();
}
}

void getString(string&s,int n= -1);


void initBits(void);
unsigned int getBits(int n);
int getSignedBits(const int n);

void getRect(rect*r);
void getMatrix(matrix*mat);
};

/*:89*//*103:*/
#line 4014 "annoyance-filter.w"

class flashTextExtractor:public flashStream{
protected:
map<unsigned short,vector<unsigned short> *> fontMap;
map<unsigned short,unsigned short> fontGlyphCount;
map<unsigned short,fontFlags> fontInfoBits;
queue<string> strings;

bool initialised;



bool textOnly;

public:
flashTextExtractor(mailFolder*f= NULL):
flashStream(f),initialised(false),textOnly(false){
}

~flashTextExtractor(){
close();
}

virtual string name(void)const{
return"Flash";
}

void setTextOnly(const bool tf){
textOnly= tf;
}

bool getTextOnly(void)const{
return textOnly;
}

bool nextString(string&s);

virtual void close(void){
while(!fontMap.empty()){
delete fontMap.begin()->second;
fontMap.erase(fontMap.begin());
}
fontGlyphCount.clear();
fontInfoBits.clear();
}
};

/*:103*//*114:*/
#line 4568 "annoyance-filter.w"

#ifdef HAVE_PDF_DECODER
class pdfTextExtractor:public applicationStringParser{
protected:
bool initialised;
ifstream is;
FILE*ip;
#ifdef HAVE_MKSTEMP
char tempfn[256];
#else
char tempfn[L_tmpnam+2];
#endif

public:
pdfTextExtractor(mailFolder*f= NULL):
applicationStringParser(f),
initialised(false),
ip(NULL){
}

~pdfTextExtractor(){
close();
}

virtual string name(void)const{
return"PDF";
}

bool nextString(string&s);

virtual void close(void){
if(ip!=NULL){
pclose(ip);
remove(tempfn);
ip= NULL;
}
}
};
#endif

/*:114*//*118:*/
#line 4685 "annoyance-filter.w"

/*121:*/
#line 4990 "annoyance-filter.w"


#ifdef HAVE_POPEN
#if (defined HAVE_GUNZIP) || (defined HAVE_GZCAT) || (defined HAVE_GZIP)
#define COMPRESSED_FILES
static const char Compressed_file_type[]= ".gz";

static const char Uncompress_command[]= 
#if(defined HAVE_GUNZIP)
"gunzip -c"
#elif(defined HAVE_GZCAT)
"gzcat"
#elif(defined HAVE_GZIP)
"gzip -cd"
#endif
;
#elif (defined HAVE_ZCAT) || (defined HAVE_UNCOMPRESS) || (defined HAVE_COMPRESS)
#define COMPRESSED_FILES
static const char Compressed_file_type[]= ".Z";

static const char Uncompress_command[]= 
#if(defined HAVE_ZCAT)
"zcat"
#elif(defined HAVE_UNCOMPRESS)
"uncompress -c"
#elif(defined HAVE_COMPRESS)
"compress -cd"
#endif
;
#endif
#endif

/*:121*/
#line 4686 "annoyance-filter.w"


class mailFolder{
public:
istream*is;
dictionaryWord::mailCategory category;
unsigned int nLines;
unsigned int nMessages;
bool newMessage;
bool inHeader;
string lookAheadLine;
bool lookedAhead;
ifstream isc;


#ifdef COMPRESSED_FILES
FILE*ip;
#endif

#ifdef HAVE_DIRECTORY_TRAVERSAL

bool dirFolder;
DIR*dh;
string dirName,cfName;
string pathSeparator;
ifstream ifdir;
istringstream nullstream;
#endif


string bodyContentType;
string bodyContentTypeCharset;
string bodyContentTransferEncoding;

string partBoundary;
bool multiPart;
bool inPartHeader;
unsigned int partHeaderLines;
stack<string> partBoundaryStack;


string mimeContentType;
string mimeContentTypeCharset;
string mimeContentTypeBoundary;
string mimeContentTransferEncoding;


MIMEdecoder*mdp;
identityMIMEdecoder imd;
base64MIMEdecoder bmd;
sinkMIMEdecoder smd;
quotedPrintableMIMEdecoder qmd;


MBCSinterpreter*mbi;
EUC_MBCSdecoder mbd_euc;
GB2312_MBCSinterpreter mbi_gb2312;
Big5_MBCSdecoder mbd_big5;
Big5_MBCSinterpreter mbi_big5;
KR_MBCSinterpreter mbi_kr;
UTF_8_Unicode_MBCSdecoder mbd_utf_8;
Unicode_MBCSinterpreter mbi_unicode;


applicationStringParser*asp;
flashTextExtractor aspFlash;
#ifdef HAVE_PDF_DECODER
pdfTextExtractor aspPdf;
#endif


bool byteStream;

list<string> *tlist;

list<string> *dlist;

mailFolder(istream&i,dictionaryWord::mailCategory cat= dictionaryWord::Unknown){
#ifdef COMPRESSED_FILES
ip= NULL;
#endif 
set(&i,cat);
}

mailFolder(string fname,dictionaryWord::mailCategory cat= dictionaryWord::Unknown){
#ifdef COMPRESSED_FILES
ip= NULL;
#endif 
/*124:*/
#line 5074 "annoyance-filter.w"

#ifdef HAVE_DIRECTORY_TRAVERSAL
dirFolder= false;
struct stat fs;

if((stat(fname.c_str(),&fs)==0)&&S_ISDIR(fs.st_mode)){
dh= opendir(fname.c_str());
if(dh!=NULL){
dirFolder= true;
dirName= fname;
pathSeparator= '/';
if(!findNextFileInDirectory(fname)){
nullstream.str("");
is= &nullstream;
}else{
if(verbose){
cerr<<"Processing files from directory \""<<
dirName<<"\"."<<endl;
}
}
}else{
cerr<<"Cannot open mail folder directory \""<<fname<<"\""<<endl;
exit(1);
}
}
#endif

/*:124*/
#line 4774 "annoyance-filter.w"
;

#ifdef HAVE_DIRECTORY_TRAVERSAL
if(!dirFolder){
#endif 
#ifdef COMPRESSED_FILES
/*122:*/
#line 5032 "annoyance-filter.w"

#ifdef HAVE_READLINK
int maxSlinks= 50;

string jname= fname;
char slbuf[1024];
while(maxSlinks--> 0){
int sll= readlink(jname.c_str(),slbuf,(sizeof slbuf)-1);
if(sll>=0){
assert(sll<static_cast<int> (sizeof slbuf));
slbuf[sll]= 0;
jname= slbuf;
}else{
break;
}
}
if(maxSlinks<=0){
cerr<<"Warning: probable symbolic link loop for \""<<
fname<<"\""<<endl;
}
#endif

/*:122*/
#line 4780 "annoyance-filter.w"
;

if(jname.rfind(Compressed_file_type)!=string::npos){
/*123:*/
#line 5061 "annoyance-filter.w"

string cmd(Uncompress_command);
cmd+= ' '+fname;
ip= popen(cmd.c_str(),"r");
isc.attach(fileno(ip));
is= &isc;

/*:123*/
#line 4783 "annoyance-filter.w"
;
}else{
#endif
if(fname=="-"){
is= &cin;
}else{
isc.open(fname.c_str());
is= &isc;
}
#ifdef COMPRESSED_FILES
}
#endif
#ifdef HAVE_DIRECTORY_TRAVERSAL
}
#endif
if(!(*is)){
cerr<<"Cannot open mail folder file "<<fname<<endl;
exit(1);
}
set(is,cat);
}

~mailFolder(){
#ifdef COMPRESSED_FILES
if(ip!=NULL){
pclose(ip);
}
#endif
}

void set(istream*i,dictionaryWord::mailCategory cat= dictionaryWord::Unknown){
is= i;
nLines= nMessages= 0;
lookedAhead= false;
lookAheadLine= "";
category= cat;
dlist= NULL;
tlist= NULL;
/*131:*/
#line 5289 "annoyance-filter.w"

mimeContentType= mimeContentTypeCharset= 
mimeContentTypeBoundary= mimeContentTransferEncoding= "";
mdp= NULL;
mbi= NULL;
asp= NULL;
byteStream= false;

/*:131*/
#line 4821 "annoyance-filter.w"
;
bodyContentType= bodyContentTypeCharset= bodyContentTransferEncoding= "";
}

void setCategory(dictionaryWord::mailCategory c){
category= c;
}

dictionaryWord::mailCategory getCategory(void)const{
return category;
}

bool nextLine(string&s);

int nextByte(void);

#ifdef HAVE_DIRECTORY_TRAVERSAL
bool findNextFileInDirectory(string&fname);
bool openNextFileInDirectory(void);
#endif

static void stringCanonicalise(string&s);

static bool compareHeaderField(string&s,const string target,string&arg);

static bool parseHeaderArgument(string&s,const string target,string&arg);

bool isNewMessage(void)const{
return newMessage;
}

unsigned int getMessageCount(void)const{
return nMessages;
}

unsigned int getLineCount(void)const{
return nLines;
}

bool isByteStream(void)const{
return byteStream;
}

void describe(ostream&os= cout)const{
os<<"Mail folder.  Category: "<<dictionaryWord::categoryName(category)<<endl;
os<<"  Lines: "<<getLineCount()<<"  Messages: "<<getMessageCount()<<endl;
}

void setDiagnosticList(list<string> *lp){
dlist= lp;
}

void setTranscriptList(list<string> *lp){
tlist= lp;
}

void writeMessageTranscript(ostream&os= cout);
void writeMessageTranscript(const string fname= "-");

void reportParserDiagnostic(const string s)const;
void reportParserDiagnostic(const ostringstream&os)const;
};

/*:118*//*155:*/
#line 6048 "annoyance-filter.w"

class tokenDefinition{
protected:
static const int numTokenChars= 256;
bool isToken[numTokenChars],
notExclusively[numTokenChars],
notAtEnd[numTokenChars];
unsigned int minTokenLength,maxTokenLength;

public:
tokenDefinition(){
clear();
}

void clear(void){
for(int i= 0;i<numTokenChars;i++){
isToken[i]= notExclusively[i]= notAtEnd[i]= false;
}
setLengthLimits(1,65535);
}

void setLengthLimits(unsigned int lmin= 0,unsigned int lmax= 0){
if(lmin> 0){
minTokenLength= lmin;
}
if(lmax> 0){
maxTokenLength= lmax;
}
}

unsigned int getLengthMin(void)const{
return minTokenLength;
}

unsigned int getLengthMax(void)const{
return maxTokenLength;
}

bool isTokenMember(const int c)const{
assert(c>=0&&c<numTokenChars);
return isToken[c];
}

bool isTokenNotExclusively(const int c)const{
assert(c>=0&&c<numTokenChars);
return notExclusively[c];
}

bool isTokenNotAtEnd(const int c)const{
assert(c>=0&&c<numTokenChars);
return notAtEnd[c];
}

bool isTokenLengthAcceptable(string::size_type l)const{
return(l>=minTokenLength)&&(l<=maxTokenLength);
}

bool isTokenLengthAcceptable(const string t)const{
return isTokenLengthAcceptable(t.length());
}

void setTokenMember(bool v,const int cstart,const int cend= -1){
assert(cstart>=0&&cstart<=numTokenChars);
assert((cend==-1)||(cend>=cstart&&cend<=numTokenChars));
for(int i= cstart;i<=cend;i++){
isToken[i]= v;
}
}

void setTokenNotExclusively(bool v,const int cstart,const int cend= -1){
assert(cstart>=0&&cstart<=numTokenChars);
assert((cend==-1)||(cend>=cstart&&cend<=numTokenChars));
for(int i= cstart;i<=cend;i++){
notExclusively[i]= v;
}
}

void setTokenNotAtEnd(bool v,const int cstart,const int cend= -1){
assert(cstart>=0&&cstart<=numTokenChars);
assert((cend==-1)||(cend>=cstart&&cend<=numTokenChars));
for(int i= cstart;i<=cend;i++){
notAtEnd[i]= v;
}
}

void setISO_8859defaults(unsigned int lmin= 0,unsigned int lmax= 0);
void setUS_ASCIIdefaults(unsigned int lmin= 0,unsigned int lmax= 0);
};

/*:155*//*158:*/
#line 6184 "annoyance-filter.w"

class tokenParser{
protected:
mailFolder*source;
string cl;
string::size_type clp;
bool atEnd,inHTML,inHTMLcomment;
tokenDefinition*td;
tokenDefinition*btd;

bool saveMessage;

bool assemblePhrases;
deque<string> phraseQueue;
deque<string> pendingPhrases;

public:
list<string> messageQueue;

tokenParser(){
td= NULL;
}

void setSource(mailFolder&mf){
source= &mf;
cl= "";
clp= 0;
atEnd= inHTML= inHTMLcomment= false;
saveMessage= false;
messageQueue.clear();
phraseQueue.clear();
pendingPhrases.clear();
/*164:*/
#line 6592 "annoyance-filter.w"

assemblePhrases= false;
if((phraseMin!=1)||(phraseMax!=1)){
if((phraseMin>=1)&&(phraseMax>=phraseMin)){
if((phraseLimit> 0)&&(phraseLimit<((phraseMax*2)-1))){
cerr<<"Invalid --phraselimit setting.  Too small for specified --phrasemax."<<endl;
}else{
assemblePhrases= true;
}
}else{
cerr<<"Invalid --phrasemin/max parameters.  Must be 1 <= min <= max."<<endl;
}
}

/*:164*/
#line 6216 "annoyance-filter.w"
;
}

void setTokenDefinition(tokenDefinition&t,tokenDefinition&bt){
td= &t;
btd= &bt;
}

void setTokenLengthLimits(unsigned int lMax,unsigned int lMin= 1,
unsigned int blMax= 1,unsigned int blMin= 1){
assert(td!=NULL);
td->setLengthLimits(lMin,lMax);
assert(btd!=NULL);
btd->setLengthLimits(blMin,blMax);
}

unsigned int getTokenLengthMin(void)const{
return td->getLengthMin();
}

unsigned int getTokenLengthMax(void)const{
return td->getLengthMax();
}

void reportParserDiagnostic(const string s)const{
assert(source!=NULL);
source->reportParserDiagnostic(s);
}

void reset(void){
if(inHTML){
reportParserDiagnostic("<HTML> tag unterminated at end of message.");
}
if(inHTMLcomment){
reportParserDiagnostic("HTML comment unterminated at end of message.");
}
inHTML= inHTMLcomment= false;
clearMessageQueue();
phraseQueue.clear();
pendingPhrases.clear();
}

bool nextToken(dictionaryWord&d);

void assembleAllPhrases(dictionaryWord&d);

/*167:*/
#line 6669 "annoyance-filter.w"

void setSaveMessage(bool v){
saveMessage= v;
source->setDiagnosticList(saveMessage?(&messageQueue):NULL);
}

bool getSaveMessage(void)const{
return saveMessage;
}

void clearMessageQueue(void){
if(saveMessage){
string s;

if(isNewMessage()){
s= messageQueue.back();
}
messageQueue.clear();
if(isNewMessage()){
messageQueue.push_back(s);
}
}
}

void writeMessageQueue(ostream&os){
list<string> ::size_type l= messageQueue.size(),n= 0;

for(list<string> ::iterator p= messageQueue.begin();
p!=messageQueue.end();p++,n++){
if(!((n==(l-1))&&
(p->substr(0,(sizeof messageSentinel)-1)==messageSentinel))){
os<<*p<<endl;
}
}
}

/*:167*/
#line 6262 "annoyance-filter.w"
;

bool isNewMessage(void)const{
return atEnd||(source->isNewMessage());
}

private:
void nextLine(void){
while(true){
if(!(source->nextLine(cl))){
atEnd= true;
cl= "";
break;
}
if(saveMessage){
messageQueue.push_back(cl);
}
if(source->isNewMessage()){
reset();
}
break;
}
clp= 0;
}
};

/*:158*//*168:*/
#line 6712 "annoyance-filter.w"

class classifyMessage{
public:
mailFolder*mf;
tokenParser tp;
unsigned int nExtremal;
dictionary*d;
double unknownWordProbability;

classifyMessage(mailFolder&m,
dictionary&dt,
unsigned int nExt= 15,double uwp= 0.2);

double classifyThis(void);

protected:
void addSignificantWordDiagnostics(list<string> &l,
list<string> ::iterator where,
multimap<double,string> &rtokens);
};

/*:168*//*171:*/
#line 6796 "annoyance-filter.w"

double abs(double x){
return(x<0)?(-(x)):x;
}

/*:171*/
#line 7820 "annoyance-filter.w"

/*192:*/
#line 7258 "annoyance-filter.w"

static double mailBias= 2.0;
static unsigned int minOccurrences= 5;
static double junkThreshold= 0.9;
static double mailThreshold= 0.9;
static int significantWords= 15;
static double novelWordProbability= 0.2;
static bitset<1<<(sizeof(char)*8)> annotations;

/*:192*//*193:*/
#line 7271 "annoyance-filter.w"

static unsigned int nTested= 0;

/*:193*/
#line 7821 "annoyance-filter.w"

/*9:*/
#line 1169 "annoyance-filter.w"

bool operator<(dictionaryWord a,dictionaryWord b){
return a.get()<b.get();
}

/*:9*//*10:*/
#line 1204 "annoyance-filter.w"

void dictionaryWord::computeJunkProbability(unsigned int nMailMessages,unsigned int nJunkMessages,
double mailBias,unsigned int minOccurrences)
{
double nMail= occurrences[Mail]*mailBias,
nJunk= occurrences[Junk];

nMailMessages= max(nMailMessages,1u);
nJunkMessages= max(nJunkMessages,1u);

if((nMail+nJunk)>=minOccurrences){
assert(nMailMessages> 0);
assert(nJunkMessages> 0);
junkProbability= min(0.99,max(0.01,min(nJunk/nJunkMessages,1.0)/
(min(nMail/nMailMessages,1.0)+min(nJunk/nJunkMessages,1.0))));
}else{
junkProbability= -1;
}
}

/*:10*//*11:*/
#line 1229 "annoyance-filter.w"

void dictionaryWord::describe(ostream&os){
os<<text<<
"  Mail: "<<n_mail()<<", Junk: "<<n_junk()<<
", Probability: "<<setprecision(5)<<junkProbability<<endl;
}

/*:11*//*12:*/
#line 1242 "annoyance-filter.w"

void dictionaryWord::exportCSV(ostream&os){
os<<setprecision(5)<<junkProbability<<","<<
occurrences[Mail]<<","<<occurrences[Junk]<<",\""<<
text<<"\""<<endl;
}

/*:12*//*13:*/
#line 1267 "annoyance-filter.w"

bool dictionaryWord::importCSV(istream&is= cin){
while(true){
string s;

if(getline(is,s)){
string::size_type p,p1,p2;

for(p= 0;p<s.length();p++){
if(!isISOspace(s[p])){
break;
}
}
if((p>=s.length())||(s[p]=='#')||(s[p]==';')){
continue;
}

if((s[p]=='-')||isdigit(s[p])){
p= s.find(',');
if(p!=string::npos){
p1= s.find(',',p+1);
if(p1!=string::npos){
p2= s.find(',',p1+1);
if(p2!=string::npos){
junkProbability= atof(s.substr(0,p).c_str());
occurrences[Mail]= atoi(s.substr(p+1,p1-p).c_str());
occurrences[Junk]= atoi(s.substr(p1+1,p2-p).c_str());
p= s.find('"',p2+1);
if(p!=string::npos){
p1= s.find_last_of('"');
if((p1!=string::npos)&&(p1> p)){
text= s.substr(p+1,(p1-p)-1);
return true;
}
}
}
}
}
}

junkProbability= -2;
text= s;
return true;
}
junkProbability= -3;
return false;
}
}

/*:13*//*14:*/
#line 1326 "annoyance-filter.w"

void dictionaryWord::exportToBinaryFile(ostream&os){
unsigned char c;
const unsigned char*fp;
const double k1= -1.0;

#define outCount(x) assert(x <= 255); c =  (x); os.put(c)
#define outNumber(x) os.put((x >> 24) & 0xFF); os.put((x >> 16) & 0xFF); \
               os.put((x >> 8) & 0xFF); os.put(x & 0xFF)

outCount(text.length());
os.write(text.data(),text.length());
outNumber(n_mail());
outNumber(n_junk());
fp= reinterpret_cast<const unsigned char*> (&k1);
if(fp[0]==0){
fp= reinterpret_cast<unsigned char*> (&junkProbability);
for(unsigned int i= 0;i<(sizeof junkProbability);i++){
outCount(fp[((sizeof junkProbability)-1)-i]);
}
}else{

os.write(&junkProbability,sizeof junkProbability);
}

#undef outCount
#undef outNumber
}

/*:14*//*15:*/
#line 1361 "annoyance-filter.w"

bool dictionaryWord::importFromBinaryFile(istream&is){
unsigned char c;
char sval[256];
unsigned char ibyte[4];
unsigned char fb[8];
unsigned char*fp;
const double k1= -1.0;
const unsigned char*kp;

#define iNumber ((ibyte[0] << 24) | (ibyte[1] << 16) | (ibyte[2] << 8) | ibyte[3])
if(is.read(&c,1)){
if(is.read(sval,c)){
text= string(sval,c);
is.read(ibyte,4);
occurrences[Mail]= iNumber;
is.read(ibyte,4);
occurrences[Junk]= iNumber;
kp= reinterpret_cast<const unsigned char*> (&k1);
if(kp[0]==0){
is.read(fb,8);
fp= reinterpret_cast<unsigned char*> (&junkProbability);
for(unsigned int i= 0;i<(sizeof junkProbability);i++){
fp[((sizeof junkProbability)-1)-i]= fb[i];
}
}else{
is.read(&junkProbability,sizeof junkProbability);
}
return true;
}
}
return false;
#undef iNumber
}

/*:15*//*18:*/
#line 1456 "annoyance-filter.w"

void dictionary::add(dictionaryWord w,dictionaryWord::mailCategory category){
dictionary::iterator p;

if((p= find(w.get()))!=end()){
p->second.add(category);
}else{
insert(make_pair(w.get(),w)).first->second.add(category);
}
}


/*:18*//*19:*/
#line 1476 "annoyance-filter.w"

void dictionary::include(dictionaryWord&w){
dictionary::iterator p;

if((p= find(w.get()))!=end()){
p->second.occurrences[dictionaryWord::Mail]+= w.occurrences[dictionaryWord::Mail];
p->second.occurrences[dictionaryWord::Junk]+= w.occurrences[dictionaryWord::Junk];
}else{
insert(make_pair(w.get(),w));
}
}

/*:19*//*20:*/
#line 1497 "annoyance-filter.w"

bool byProbability(const dictionaryWord*w1,
const dictionaryWord*w2){
double dp= w1->getJunkProbability()-w2->getJunkProbability();
if(dp==0){
return w1->get()<w2->get();
}
return dp<0;
}

void dictionary::exportCSV(ostream&os){
if(verbose){
cerr<<"Exporting dictionary to CSV file."<<endl;
}
vector<dictionaryWord*> dv;
for(iterator p= begin();p!=end();p++){
dv.push_back(&(p->second));
}
sort(dv.begin(),dv.end(),byProbability);
os<<"; Probability,Mail,Junk,Word"<<endl;
dictionaryWord pdw;

pdw.set(pseudoCountsWord,
messageCount[dictionaryWord::Mail],
messageCount[dictionaryWord::Junk],-1);
pdw.exportCSV(os);
for(vector<dictionaryWord*> ::iterator q= dv.begin();q!=dv.end();q++){
(*q)->exportCSV(os);
}
}

/*:20*//*21:*/
#line 1538 "annoyance-filter.w"

void dictionary::importCSV(istream&is){
if(verbose){
cerr<<"Importing dictionary from CSV file."<<endl;
}

dictionaryWord dw;

while(dw.importCSV(is)){
if(dw.getJunkProbability()==-1&&(dw.get()==pseudoCountsWord)){
messageCount[dictionaryWord::Mail]+= dw.n_mail();
messageCount[dictionaryWord::Junk]+= dw.n_junk();
}else if(dw.getJunkProbability()>=-1){
include(dw);
}else{
if(verbose){
cerr<<"Ill-formed record in CSV import: \""<<dw.get()<<"\""<<endl;
}
}
}
}

/*:21*//*22:*/
#line 1599 "annoyance-filter.w"

#ifdef PURGE_USES_REMOVE_IF
class dictionaryWordProb_less:public unary_function<pair<string,dictionaryWord> ,int> {
int p;
public:
explicit dictionaryWordProb_less(const int pt):p(pt){}
bool operator()(const pair<string,dictionaryWord> &dw)const{
return dw.second.getJunkProbability()<p;
}
};
#endif

void dictionary::purge(void){
if(verbose){
cerr<<"Pruning rare words from database: "<<flush;
}

#ifdef PURGE_USES_REMOVE_IF
remove_if(begin(),end(),dictionaryWordProb_less(0));
#else
queue<dictionaryWord> pq;
while(!empty()){
if(begin()->second.getJunkProbability()>=0){
pq.push(begin()->second);
}
erase(begin());
}
while(!pq.empty()){
insert(make_pair(pq.front().get(),pq.front()));
pq.pop();
}
#endif

if(verbose){
cerr<<size()<<" words remaining."<<endl;
}
}

/*:22*//*23:*/
#line 1641 "annoyance-filter.w"

void dictionary::resetCat(dictionaryWord::mailCategory category){
if(verbose){
cerr<<"Resetting counts for category "<<
dictionaryWord::categoryName(category)<<endl;
}
for(iterator mp= begin();mp!=end();mp++){
mp->second.resetCat(category);
}
}

/*:23*//*24:*/
#line 1658 "annoyance-filter.w"

void dictionary::printStatistics(ostream&os)const{
if(verbose){
cerr<<"Computing dictionary statistics."<<endl;
}
os<<"Dictionary statistics:"<<endl;
dataTable<double> dt;

for(const_iterator mp= begin();mp!=end();mp++){
if(mp->second.getJunkProbability()>=0){
dt.push_back(mp->second.getJunkProbability());
}
}
os<<"Mean = "<<dt.mean()<<endl;
os<<"Geometric mean = "<<dt.geometricMean()<<endl;
os<<"Harmonic mean = "<<dt.harmonicMean()<<endl;
os<<"RMS = "<<dt.RMS()<<endl;
os<<"Median = "<<dt.median()<<endl;
os<<"Mode = "<<dt.mode()<<endl;
os<<"Percentile(0.5) = "<<dt.percentile(0.5)<<endl;
os<<"Quartile(1) = "<<dt.quartile(1)<<endl;
os<<"Quartile(3) = "<<dt.quartile(3)<<endl;

os<<"Variance = "<<dt.variance()<<endl;
os<<"Standard deviation = "<<dt.stdev()<<endl;
os<<"CentralMoment(3) = "<<dt.centralMoment(3)<<endl;
os<<"Skewness = "<<dt.skewness()<<endl;
os<<"Kurtosis = "<<dt.kurtosis()<<endl;
}

/*:24*//*25:*/
#line 1693 "annoyance-filter.w"

#ifdef HAVE_PLOT_UTILITIES
#define PLOT_DEBUG
void dictionary::plotProbabilityHistogram(string fileName,unsigned int nBins)const{
if(verbose){
cerr<<"Plotting probability histogram to "<<fileName<<".png"<<endl;
}
ofstream gp((fileName+".gp").c_str()),
dat((fileName+".dat").c_str());

/*26:*/
#line 1737 "annoyance-filter.w"

vector<unsigned int> hist(nBins);

for(const_iterator mp= begin();mp!=end();mp++){
if(mp->second.getJunkProbability()>=0){
unsigned int bin= static_cast<unsigned int> (mp->second.getJunkProbability()*nBins);

hist[bin]++;
}
}

/*:26*/
#line 1703 "annoyance-filter.w"
;
/*27:*/
#line 1753 "annoyance-filter.w"

for(unsigned int j= 0;j<nBins;j++){
dat<<(static_cast<double> (j)/nBins)<<" "<<hist[j]<<endl;
}


/*:27*/
#line 1704 "annoyance-filter.w"
;



gp<<"set term pbm small color"<<endl;
gp<<"set ylabel \"Number of Words\""<<endl;
gp<<"set xlabel \"Probability\""<<endl;

gp<<"plot \""<<fileName<<".dat\" using 1:2 title \"\" with boxes"<<endl;

string command("gnuplot ");
command+= fileName+".gp | pnmtopng >"+fileName+".png";
#ifdef PLOT_DEBUG
cout<<command<<endl;
#else
command+= " 2>/dev/null";
#endif
gp.close();
dat.close();
system(command.c_str());
#ifndef PLOT_DEBUG

remove((fileName+".gp").c_str());
remove((fileName+".dat").c_str());
#endif
}
#endif 

/*:25*//*28:*/
#line 1764 "annoyance-filter.w"

void dictionary::computeJunkProbability(unsigned int nMailMessages,unsigned int nJunkMessages,
double mailBias,unsigned int minOccurrences)
{
for(dictionary::iterator p= begin();p!=end();p++){
p->second.computeJunkProbability(nMailMessages,nJunkMessages,
mailBias,minOccurrences);
}
}

/*:28*//*29:*/
#line 1794 "annoyance-filter.w"

void dictionary::exportToBinaryFile(ostream&os){
if(verbose){
cerr<<"Exporting dictionary to binary file."<<endl;
}
dictionaryWord pdw;

pdw.set(pseudoCountsWord,
messageCount[dictionaryWord::Mail],
messageCount[dictionaryWord::Junk],-1);
pdw.exportToBinaryFile(os);

for(dictionary::iterator p= begin();p!=end();p++){
p->second.exportToBinaryFile(os);
}
}

void dictionary::importFromBinaryFile(istream&is){
if(verbose){
cerr<<"Importing dictionary from binary file."<<endl;
}

dictionaryWord dw;

if(dw.importFromBinaryFile(is)){
assert(dw.get()==pseudoCountsWord);
messageCount[dictionaryWord::Mail]+= dw.n_mail();
messageCount[dictionaryWord::Junk]+= dw.n_junk();

while(dw.importFromBinaryFile(is)){
include(dw);
}
}
}

/*:29*//*31:*/
#line 1931 "annoyance-filter.w"

bool MIMEdecoder::getNextEncodedLine(void){
if(!atEnd){
if(getline(*is,inputLine)!=NULL){
if(inputLine.substr(0,(sizeof messageSentinel)-1)==messageSentinel){
endBoundary= inputLine;
if(partBoundary!=""){
assert(mf!=NULL);
mf->reportParserDiagnostic("Unterminated MIME sentinel at end of message.");
}
atEnd= true;
}
if((partBoundary!="")&&(inputLine.substr(0,2)=="--")&&
(inputLine.substr(2,partBoundary.length())==partBoundary)){
if(Annotate('d')){
ostringstream os;

os<<"Part boundary encountered: "<<inputLine;
mf->reportParserDiagnostic(os);
}
endBoundary= inputLine;
atEnd= true;
}else{
if(tlist!=NULL){
tlist->push_back(inputLine);
}
ip= 0;
encodedLineCount++;
}
}else{
atEnd= true;
eofHit= true;
}
}
if(atEnd){
inputLine= "";
ip= 0;
}
return!atEnd;
}

/*:31*//*32:*/
#line 1978 "annoyance-filter.w"

bool MIMEdecoder::getDecodedLine(string&s){
int ch;

s= "";
while(true){
if(lookAhead){
ch= lookChar;
lookAhead= false;
}else{
ch= getDecodedChar();
}
if(ch<0){
break;
}
/*33:*/
#line 2008 "annoyance-filter.w"

if(ch=='\r'||ch=='\n'){
int cht= getDecodedChar();

if(!(((ch=='\r')&&(cht=='\n'))||
((ch=='\n')&&(cht=='\r')))){
lookAhead= true;
lookChar= cht;
}
return true;
}

/*:33*/
#line 1993 "annoyance-filter.w"
;
s+= ch;
}
return s.length()> 0;
}

/*:32*//*34:*/
#line 2025 "annoyance-filter.w"

void MIMEdecoder::saveDecodedStream(ostream&os){
int ch;

while((ch= getDecodedChar())>=0){
os.put(ch);
}
}

/*:34*//*35:*/
#line 2038 "annoyance-filter.w"

void MIMEdecoder::saveDecodedStream(const string fname){
ofstream of(fname.c_str());

if(!of){
if(verbose){
cerr<<"Cannot create MIMEdecoder dump file: "<<fname<<endl;
}
}else{
saveDecodedStream(of);
of.close();
}
}

/*:35*//*39:*/
#line 2153 "annoyance-filter.w"

int base64MIMEdecoder::getDecodedChar(void){
/*45:*/
#line 2282 "annoyance-filter.w"

if(lookAhead){
lookAhead= false;
return lookChar;
}

/*:45*/
#line 2155 "annoyance-filter.w"
;
if(decodedBytes.size()==0){
/*40:*/
#line 2178 "annoyance-filter.w"

unsigned char a[4],b[4],o[3];
int j,k;

/*41:*/
#line 2193 "annoyance-filter.w"

for(int i= 0;i<4;i++){
int c;

/*42:*/
#line 2219 "annoyance-filter.w"

while(true){
c= -1;
while(ip<inputLine.length()){
if(inputLine[ip]> ' '){
c= inputLine[ip++];
break;
}
ip++;
}
if(c>=0){
break;
}
if(!getNextEncodedLine()){
break;
}
}

/*:42*/
#line 2197 "annoyance-filter.w"
;
/*43:*/
#line 2244 "annoyance-filter.w"

if(c==EOF){
if(i> 0){
nDecodeErrors++;
mf->reportParserDiagnostic("Unexpected end of file in Base64 decoding.");
}
return-1;
}

/*:43*/
#line 2198 "annoyance-filter.w"
;
if(dtable[c]&0x80){
nDecodeErrors++;
ostringstream os;
os<<"Illegal character '"<<c<<"' in Base64 input stream.";
mf->reportParserDiagnostic(os.str());


i--;
continue;
}
a[i]= (unsigned char)c;
b[i]= dtable[c];
}

/*:41*/
#line 2182 "annoyance-filter.w"
;
/*44:*/
#line 2264 "annoyance-filter.w"

o[0]= (b[0]<<2)|(b[1]>>4);
o[1]= (b[1]<<4)|(b[2]>>2);
o[2]= (b[2]<<6)|b[3];
j= a[2]=='='?1:(a[3]=='='?2:3);

for(k= 0;k<j;k++){
decodedBytes.push_back(o[k]);
}

/*:44*/
#line 2183 "annoyance-filter.w"
;

/*:40*/
#line 2157 "annoyance-filter.w"
;
}
if(decodedBytes.size()> 0){
unsigned char v= decodedBytes[0];

decodedBytes.pop_front();
return v;
}
return-1;
}

/*:39*//*46:*/
#line 2302 "annoyance-filter.w"

void base64MIMEdecoder::initialiseDecodingTable(void)
{
int i;

for(i= 0;i<255;i++){
dtable[i]= 0x80;
}
for(i= 'A';i<='I';i++){
dtable[i]= 0+(i-'A');
}
for(i= 'J';i<='R';i++){
dtable[i]= 9+(i-'J');
}
for(i= 'S';i<='Z';i++){
dtable[i]= 18+(i-'S');
}
for(i= 'a';i<='i';i++){
dtable[i]= 26+(i-'a');
}
for(i= 'j';i<='r';i++){
dtable[i]= 35+(i-'j');
}
for(i= 's';i<='z';i++){
dtable[i]= 44+(i-'s');
}
for(i= '0';i<='9';i++){
dtable[i]= 52+(i-'0');
}
dtable['+']= 62;
dtable['/']= 63;
dtable['=']= 0;
}

/*:46*//*47:*/
#line 2345 "annoyance-filter.w"

string base64MIMEdecoder::decodeEscapedText(const string s,mailFolder*m= NULL){
string r= "";
base64MIMEdecoder dc;
istringstream iss(s);
int dchar;

dc.set(&iss,m,"");

while((dchar= dc.getDecodedChar())>=0){
r+= static_cast<char> (dchar);
}

return r;
}

/*:47*//*49:*/
#line 2393 "annoyance-filter.w"

int quotedPrintableMIMEdecoder::getDecodedChar(void){
int ch;

/*45:*/
#line 2282 "annoyance-filter.w"

if(lookAhead){
lookAhead= false;
return lookChar;
}

/*:45*/
#line 2397 "annoyance-filter.w"
;

while(true){
ch= getNextChar();
if(ch=='='){
/*50:*/
#line 2417 "annoyance-filter.w"

int ch1= getNextChar();
/*53:*/
#line 2489 "annoyance-filter.w"

while(/*52:*/
#line 2475 "annoyance-filter.w"

((ch1==' ')||(ch1=='\t'))

/*:52*/
#line 2490 "annoyance-filter.w"
){
ch1= getNextChar();
if(ch1=='\n'){
continue;
}
if(!/*52:*/
#line 2475 "annoyance-filter.w"

((ch1==' ')||(ch1=='\t'))

/*:52*/
#line 2495 "annoyance-filter.w"
){
nDecodeErrors++;
ostringstream os;

os<<"Invalid character '"<<static_cast<char> (ch1)<<
"' after soft line break in Quoted-Printable MIME part.";
mf->reportParserDiagnostic(os.str());
ch1= ' ';
}
}

/*:53*/
#line 2419 "annoyance-filter.w"
;
if(ch1=='\n'){
continue;
}else{
int n1= hex_to_nybble(ch1);
int ch2= getNextChar();
int n2= hex_to_nybble(ch2);
if(n1==-1||n2==-1){
ostringstream os;

os<<"Invalid escape sequence '="<<
static_cast<char> (ch1)<<static_cast<char> (ch2)<<
"' in Quoted-Printable MIME part.";
mf->reportParserDiagnostic(os.str());
nDecodeErrors++;
}
ch= (n1<<4)|n2;
}
return ch;

/*:50*/
#line 2402 "annoyance-filter.w"
;
}else{
return ch;
}
}
}

/*:49*//*51:*/
#line 2446 "annoyance-filter.w"

int quotedPrintableMIMEdecoder::getNextChar(void){
while(true){
if(atEndOfLine){
atEndOfLine= false;
return'\n';
}
if(ip<inputLine.length()){
if(ip==(inputLine.length()-1)){
atEndOfLine= true;
}
return inputLine[ip++];
}
if(!getNextEncodedLine()){
break;
}
if(inputLine.length()==0){
atEndOfLine= true;
}
}
return-1;
}

/*:51*//*54:*/
#line 2512 "annoyance-filter.w"

int quotedPrintableMIMEdecoder::hex_to_nybble(const int ch){
if((ch>='0')&&(ch<=('0'+9))){
return ch-'0';
}else if((ch>='A')&&(ch<=('A'+5))){
return 10+(ch-'A');
}else if((ch>='a')&&(ch<=('a'+5))){
return 10+(ch-'a');
}
return-1;
}

/*:54*//*55:*/
#line 2529 "annoyance-filter.w"

string quotedPrintableMIMEdecoder::decodeEscapedText(const string s,mailFolder*m= NULL){
string r= "";
string::size_type p;

for(p= 0;p<s.length();p++){
bool decoded= false;

if(s[p]=='='){
if(p> (s.length()-3)){
if(verbose){
cerr<<"decodeEscapedText: escape too near end of string: "<<s<<endl;
}
}else{
int n1= hex_to_nybble(s[p+1]),
n2= hex_to_nybble(s[p+2]);
if((n1<0)||(n2<0)){
if(verbose){
cerr<<"decodeEscapedText: invalid escape sequence \""<<
s.substr(p,3)<<"\""<<endl;
}
}else{
r+= static_cast<char> ((n1<<4)|n2);
decoded= true;
p+= 2;
}
}
}
if(!decoded){
r+= s[p];
}
}
return r;
}

/*:55*//*59:*/
#line 2680 "annoyance-filter.w"

int MBCSdecoder::getNextNBytes(const unsigned int n){
assert((n>=1)&&(n<=4));
int v= 0;
for(unsigned int i= 0;i<n;i++){
int b= getNextEncodedByte();
if(b<0){
return b;
}
v= (v<<8)|b;
}
assert(v!=-1);
return v;
}


/*:59*//*61:*/
#line 2725 "annoyance-filter.w"

int EUC_MBCSdecoder::getNextDecodedChar(void){
int c1= getNextEncodedByte();

if((c1>=0xA1)&&(c1<=0xFE)){
int c2= getNextEncodedByte();

if((c2>=0x80)&&(c2<=0xFF)){
return(c1<<8)|c2;
}
if(c2==-1){
if(verbose){
cerr<<name()<<"_MBCSdecoder: Premature end of line in two byte character."<<endl;
return-1;
}
}






discardLine();
if(verbose){
cerr<<name()<<"_MBCSdecoder: Invalid second byte: 0x"<<
hex<<c2<<dec<<" in two byte character."<<endl;
}
return c1;
}
return c1;
}

/*:61*//*63:*/
#line 2779 "annoyance-filter.w"

int Big5_MBCSdecoder::getNextDecodedChar(void){
int c1= getNextEncodedByte();

if((c1>=0)&&((c1&0x80)!=0)){
int c2= getNextEncodedByte();

if(c2==-1){
if(verbose){
cerr<<name()<<"_MBCSdecoder: Premature end of line in two byte character."<<endl;
}
return-1;
}
return(c1<<8)|c2;
}
return c1;
}

/*:63*//*65:*/
#line 2835 "annoyance-filter.w"

int Shift_JIS_MBCSdecoder::getNextDecodedChar(void){
/*67:*/
#line 2884 "annoyance-filter.w"

if(!pending.empty()){
int pc= pending[0];
pending= pending.substr(1);
return pc;
}
/*:67*/
#line 2837 "annoyance-filter.w"
;

int c1= getNextEncodedByte();

if(c1>=0){
/*66:*/
#line 2855 "annoyance-filter.w"

if(((c1>=0x81)&&(c1<=0x9F))||
((c1>=0xE0)&&(c1<=0xEF))||
((c1>=0xF0)&&(c1<=0xFC))){
int c2= getNextEncodedByte();

if(c2==-1){
if(verbose){
cerr<<name()<<"_MBCSdecoder: Premature end of line in two byte character."<<endl;
}
return-1;
}
if(!(((c2>=0x40)&&(c2<=0x7E))||
((c2>=0x80)&&(c2<=0xFC)))){
if(verbose){
cerr<<name()<<"_MBCSdecoder: Invalid second byte in two byte character."<<endl;
}
return-1;
}
return(c1<<8)|c2;
}

/*:66*/
#line 2842 "annoyance-filter.w"
;
/*68:*/
#line 2902 "annoyance-filter.w"

switch(c1){
case 0x80:
c1= '\\';
break;

case 0xFD:
c1= 0xA9;
break;

case 0xFE:
c1= 'T';
pending= "M";
break;

case 0xFF:
c1= '.';
pending= "..";
break;
}

/*:68*/
#line 2843 "annoyance-filter.w"
;
}
return c1;
}

/*:65*//*71:*/
#line 2974 "annoyance-filter.w"

int UCS_2_Unicode_MBCSdecoder::getNextDecodedChar(void){
int c1= getNextEncodedByte();
int c2= getNextEncodedByte();

if(c2==-1){
if(verbose){
cerr<<name()<<"_MBCSdecoder: Premature end of line in two byte character."<<endl;
}
return-1;
}
if(bigEndian){
c1= (c1<<8)|c2;
}else{
c1|= (c2<<8);
}
return c1;
}

/*:71*//*73:*/
#line 3013 "annoyance-filter.w"

int UTF_8_Unicode_MBCSdecoder::getNextDecodedChar(void){
int c1= getNextEncodedByte();

if(c1<0){
return c1;
}
string::size_type nbytes= 0;
unsigned int result;

if(c1<=0x7F){
result= c1;
nbytes= 1;
}else{
unsigned char chn= c1;











while((chn&0x80)!=0){
nbytes++;
chn<<= 1;
}
if(nbytes> 6){
if(verbose){
cerr<<name()<<"_MBCSdecoder: Invalid first byte in UTF-8 encoded string"<<endl;
}
return-1;
}
result= c1&(0xFF>>(nbytes+1));
for(string::size_type i= 1;i<nbytes;i++){
c1= getNextEncodedByte();
if(c1<0){
if(verbose){
cerr<<name()<<"_MBCSdecoder: Premature end of line in UTF-8 character."<<endl;
}
return-1;
}
if((c1&0xC0)!=0x80){
cerr<<name()<<"_MBCSdecoder: Bad byte 1--n signature in UTF-8 encoded sequence"<<endl;
}
result= (result<<6)|(c1&0x3F);
}
}
return result;
}

/*:73*//*75:*/
#line 3122 "annoyance-filter.w"

int UTF_16_Unicode_MBCSdecoder::getNextDecodedChar(void){
string::size_type nwydes= 0;
int w1,w2,result;

w1= getNextUTF_16Word();
if(w1<0){
return w1;
}

if((w1<=0xD800)||(w1> 0xDFFF)){
result= w1;
nwydes= 1;
}else if((w1>=0xD800)&&(w1<=0xDBFF)){
w2= getNextUTF_16Word();
if(w2<0){
if(verbose){
cerr<<name()<<"_MBCSdecoder: Premature end of line in UTF-16 two word character."<<endl;
}
return-1;
}
nwydes= 2;
if((w2<0xDC00)||(w2> 0xDFFF)){
if(verbose){
cerr<<name()<<"_MBCSdecoder: Invalid second word surrogate in UTF-16 encoded string."<<endl;
}
return-1;
}
result= (((w1&0x3FF)<<10)|(w2&0x3FF))+0x10000;
}else{
if(verbose){
cerr<<name()<<"_MBCSdecoder: Invalid first word surrogate in UTF-16 encoded string."<<endl;
}
return-1;
}
return result;
}

/*:75*//*78:*/
#line 3216 "annoyance-filter.w"

string MBCSinterpreter::getNextDecodedChar(void){
assert(dp!=NULL);
int dc= dp->getNextDecodedChar();
if(dc<0){
return"";
}
if(dc<256){
string r(1,static_cast<char> (dc));
return r;
}
ostringstream os;
os.setf(ios::uppercase);
os<<prefix<<name()<<"-"<<hex<<dc<<dec<<suffix;
return os.str();
}

/*:78*//*79:*/
#line 3238 "annoyance-filter.w"

string MBCSinterpreter::decodeLine(const string&s){
string r= "",t;

setSource(s);
while((t= getNextDecodedChar())!=""){
r+= t;
}
return r;
}

/*:79*//*83:*/
#line 3309 "annoyance-filter.w"

string Shift_JIS_MBCSinterpreter::getNextDecodedChar(void){
assert(dp!=NULL);
int dc= dp->getNextDecodedChar();
if(dc<0){
return"";
}
if(dc<0xA1){
string r(1,static_cast<char> (dc));
return r;
}
ostringstream os;
os.setf(ios::uppercase);
if((dc>=0xA1)&&(dc<=0xDF)){
os<<"SJIS-K"<<hex<<dc<<dec;
}else{
os<<prefix<<"SJIS-"<<hex<<dc<<dec<<suffix;
}
return os.str();
}

/*:83*//*86:*/
#line 3376 "annoyance-filter.w"

string Unicode_MBCSinterpreter::getNextDecodedChar(void){
assert(dp!=NULL);
int dc= dp->getNextDecodedChar();
if(dc<0){
return"";
}
if(dc<=0xFF){
string r(1,static_cast<char> (dc));
return r;
}
ostringstream os;
os.setf(ios::uppercase);
if(((dc>=0x3200)&&(dc<0xD800))||
((dc>=0xF900)&&(dc<0xFAFF))){
os<<prefix<<"UCS-"<<hex<<dc<<dec<<suffix;
}else{
os<<"UCS-"<<hex<<dc<<dec;
}
return os.str();
}

/*:86*//*88:*/
#line 3470 "annoyance-filter.w"

unsigned char applicationStringParser::get8(void){
assert(mf!=NULL);
int ch= mf->nextByte();
if(ch==EOF){
eof= true;
}
return ch&0xFF;
}

/*:88*//*90:*/
#line 3568 "annoyance-filter.w"

void flashStream::readHeader(void){
sig[0]= get8();
sig[1]= get8();
sig[2]= get8();
if(isEOF()||(memcmp(sig,"FWS",3)!=0)){
error= true;
if(verbose){
cerr<<"Invalid signature in Flash animation file."<<endl;
}
return;
}
version= get8();
fileLength= get32();
getRect(&frameSize);
frameRate= get16();
frameCount= get16();
}

/*:90*//*91:*/
#line 3592 "annoyance-filter.w"

void flashStream::describe(ostream&os= cout){
os<<"Flash animation version "<<
static_cast<unsigned int> (version)<<endl;
os<<"  File length: "<<fileLength<<" bytes."<<endl;
os<<"  Frame size:  X: "<<frameSize.xMin<<" - "<<
frameSize.xMax<<
" Y: "<<frameSize.yMin<<" - "<<
frameSize.yMax<<endl;
os<<"  Frame rate: "<<setprecision(5)<<(frameRate/256.0)<<
" fps."<<endl;
os<<"  Frame count: "<<frameCount<<endl;
}

/*:91*//*92:*/
#line 3616 "annoyance-filter.w"

bool flashStream::nextTag(void){
unsigned short s= get16();
unsigned long l;
if(isOK()){
tType= static_cast<tagType> (s>>6);
l= s&0x3F;
if(l==0x3F){
l= get32();
}
if(isOK()){
tDataLen= l;
return tType!=stagEnd;
}
}

tType= stagEnd;
tDataLen= 0;
return false;
}

/*:92*//*93:*/
#line 3645 "annoyance-filter.w"

void flashStream::ignoreTag(unsigned int lookedAhead= 0){
if(isOK()){
assert(lookedAhead<=tDataLen);
for(unsigned int i= lookedAhead;i<tDataLen;i++){
get8();
}
}
}

/*:93*//*94:*/
#line 3666 "annoyance-filter.w"

void flashStream::getString(string&s,int n= -1){
s= "";
char ch;

if(n==-1){
while((ch= get8())!=0){
s+= ch;
}
}else{
while(n> 0){
ch= get8();
s+= ch;
n--;
}
}
}

/*:94*//*95:*/
#line 3689 "annoyance-filter.w"

void flashStream::getRect(rect*r){
initBits();
int nBits= static_cast<int> (getBits(5));
r->xMin= getSignedBits(nBits);
r->xMax= getSignedBits(nBits);
r->yMin= getSignedBits(nBits);
r->yMax= getSignedBits(nBits);
}

/*:95*//*96:*/
#line 3707 "annoyance-filter.w"

void flashStream::getMatrix(matrix*mat){
initBits();


if(getBits(1)){
int nBits= static_cast<int> (getBits(5));
mat->a= getSignedBits(nBits);
mat->d= getSignedBits(nBits);
}else{
mat->a= mat->d= 0x00010000L;
}


if(getBits(1)){
int nBits= static_cast<int> (getBits(5));
mat->b= getSignedBits(nBits);
mat->c= getSignedBits(nBits);
}else{
mat->b= mat->c= 0;
}


int nBits= static_cast<int> (getBits(5));
mat->tx= getSignedBits(nBits);
mat->ty= getSignedBits(nBits);
}

/*:96*//*98:*/
#line 3783 "annoyance-filter.w"

void flashStream::initBits(void){

bitPos= 0;
bitBuf= 0;
}


unsigned int flashStream::getBits(int n){
unsigned int v= 0;

while(true){
int s= n-bitPos;
if(s> 0){

v|= bitBuf<<s;
n-= bitPos;


bitBuf= get8();
bitPos= 8;
}else{

v|= bitBuf>>-s;
bitPos-= n;
bitBuf&= 0xFF>>(8-bitPos);

return v;
}
}
}


int flashStream::getSignedBits(const int n){
signed int v= static_cast<int> (getBits(n));


if(v&(1<<(n-1))){

v|= -1<<n;
}
return v;
}

/*:98*//*104:*/
#line 4075 "annoyance-filter.w"

bool flashTextExtractor::nextString(string&s){
if(!initialised){
initialised= true;
readHeader();
if(!isOK()){
if(verbose){
cerr<<"Invalid header in Flash application file."<<endl;
close();
while(!isEOF()){
get8();
}
return false;
}
}
}
while(true){
haveStrings:
/*105:*/
#line 4159 "annoyance-filter.w"

if(!strings.empty()){
s= strings.front();
strings.pop();
return true;
}

/*:105*/
#line 4093 "annoyance-filter.w"
;

while((!isEOF())&&(!isError())&&nextTag()){
unsigned int variant= 0;

switch(tType){
case stagDefineFont:
/*106:*/
#line 4171 "annoyance-filter.w"

{
#ifdef FLASH_PARSE_DEBUG
cout<<"DefineFont"<<endl;
#endif
unsigned short fontID= get16();
unsigned int offsetTable= get16();
#ifdef FLASH_PARSE_DEBUG
cout<<"  Font ID: "<<fontID<<endl;
cout<<"  Glyph count: "<<(offsetTable/2)<<endl;
#endif
fontGlyphCount.insert(make_pair(fontID,offsetTable/2));
ignoreTag(2*2);
}

/*:106*/
#line 4100 "annoyance-filter.w"
;
break;

case stagDefineFont2:
/*107:*/
#line 4191 "annoyance-filter.w"

{
#ifdef FLASH_PARSE_DEBUG
cout<<"DefineFont2"<<endl;
#endif
unsigned short fontID= get16();
get16();


unsigned int fontNameLen= get8();
string fontName;
getString(fontName,fontNameLen);
if(!textOnly){
strings.push(fontName);
}


unsigned int nGlyphs= get16();
fontGlyphCount.insert(make_pair(fontID,nGlyphs));
ignoreTag(2+2+1+fontNameLen+2);
}

/*:107*/
#line 4104 "annoyance-filter.w"
;
break;

case stagDefineFontInfo:
/*108:*/
#line 4224 "annoyance-filter.w"

{
#ifdef FLASH_PARSE_DEBUG
cout<<"DefineFontInfo"<<endl;
#endif
unsigned short fontID= get16();
unsigned int fontNameLen= get8();
string fontName;
getString(fontName,fontNameLen);
if(!textOnly){
strings.push(fontName);
}
fontFlags fFlags= static_cast<fontFlags> (get8());
map<unsigned short,unsigned short> ::iterator fp= fontGlyphCount.find(fontID);
if(fp==fontGlyphCount.end()){
if(verbose){
cerr<<"DefineFontInfo for font ID "<<fontID<<
" without previous DefineFont."<<endl;
}
ignoreTag(4);
}else{
unsigned nGlyphs= fp->second;
vector<unsigned short> *v= new vector<unsigned short> (nGlyphs);
fontMap.insert(make_pair(fontID,v));
fontInfoBits.insert(make_pair(fontID,fFlags));

for(unsigned int g= 0;g<nGlyphs;g++){
if(fFlags&fontWideCodes){
(*v)[g]= get16();
}else{
(*v)[g]= get8();
}
}
}
}

/*:108*/
#line 4108 "annoyance-filter.w"
;
break;

case stagDefineText2:
variant= 2;



case stagDefineText:
/*109:*/
#line 4267 "annoyance-filter.w"

{
#ifdef FLASH_PARSE_DEBUG
unsigned short textID= get16();
cout<<"DefineText.  ID = "<<textID<<endl;
#else
get16();
#endif
rect tr;
getRect(&tr);
matrix tm;
getMatrix(&tm);
unsigned short textGlyphBits= get8();
unsigned short textAdvanceBits= get8();
int fontId= -1;
map<unsigned short,vector<unsigned short> *> ::iterator fontp= fontMap.end();
map<unsigned short,unsigned short> ::iterator fgcp= fontGlyphCount.end();
unsigned int fGlyphs= 0;
fontFlags fFlags= static_cast<fontFlags> (0);

vector<unsigned short> *fontChars= NULL;



while(true){
unsigned int textRecordType= get8();
if(textRecordType==0){
break;
}

if(textRecordType&isTextControl){
#ifdef FLASH_PARSE_DEBUG
cout<<"Text control record."<<endl;
#endif
if(textRecordType&textHasFont){
fontId= get16();
#ifdef FLASH_PARSE_DEBUG
cout<<"    fontId: "<<fontId<<endl;
#endif
fgcp= fontGlyphCount.find(fontId);
if(fgcp==fontGlyphCount.end()){
fontp= fontMap.end();
if(verbose){
cerr<<"Flash DefineText item references undefined font ID "<<
fontId<<endl;
}
}else{
fGlyphs= fgcp->second;
fontChars= fontMap.find(fontId)->second;
fFlags= fontInfoBits.find(fontId)->second;
}
}
if(textRecordType&textHasColor){
#ifdef FLASH_PARSE_DEBUG
int r= get8();
int g= get8();
int b= get8();
if(variant==2){
int a= get8();
cout<<"    tfontColour: ("<<r<<","<<
g<<","<<b<<","<<a<<")"<<endl;
}else{
cout<<"    tfontColour: ("<<r<<","<<
g<<","<<b<<")"<<endl;
}
#else
skip8n(3);
#endif
}
if(textRecordType&textHasXOffset){
#ifdef FLASH_PARSE_DEBUG
int iXOffset= get16();
cout<<"    X offset "<<iXOffset<<endl;
#else
get16();
#endif
}
if(textRecordType&textHasYOffset){
#ifdef FLASH_PARSE_DEBUG
int iYOffset= get16();
cout<<"    Y offset "<<iYOffset<<endl;
#else
get16();
#endif
}
if(textRecordType&textHasFont){
#ifdef FLASH_PARSE_DEBUG
int iFontHeight= get16();
cout<<"    Font Height: "<<iFontHeight<<endl;
#else
get16();
#endif
}
}else{
#ifdef FLASH_PARSE_DEBUG
cout<<"Text glyph record."<<endl;
#endif
unsigned int nGlyphs= textRecordType&0x7F;

initBits();
string s= "";

for(unsigned int i= 0;i<nGlyphs;i++){
unsigned int iIndex= getBits(textGlyphBits);
#ifdef FLASH_PARSE_DEBUG
unsigned int iAdvance= getBits(textAdvanceBits);
cout<<"["<<iIndex<<","<<iAdvance<<"] "<<flush;
#else
getBits(textAdvanceBits);
#endif
if(fontId<0){
if(verbose){
cerr<<"Flash DefineText does not specify font."<<endl;
}
}else if(fgcp!=fontGlyphCount.end()){
if(iIndex>=fGlyphs){
if(verbose){
cerr<<"Flash DefineText glyph index "<<
iIndex<<" exceeds font size of "<<fGlyphs<<"."<<
endl;
}
}else{
if(fFlags&fontWideCodes){
unsigned int wc= (*fontChars)[iIndex];
s+= static_cast<char> ((wc>>8)&0xFF);
s+= static_cast<char> (wc&0xFF);
}else{
s+= static_cast<char> ((*fontChars)[iIndex]);
}
}
}
}
#ifdef FLASH_PARSE_DEBUG
cout<<endl;
cout<<"Decoded: ("<<s<<")"<<endl;
#endif
/*110:*/
#line 4414 "annoyance-filter.w"

if(fFlags&fontUnicode){
UCS_2_Unicode_MBCSdecoder mbd_ucs;
Unicode_MBCSinterpreter mbi_ucs;

mbi_ucs.setDecoder(mbd_ucs);
s= mbi_ucs.decodeLine(s);
}else if(fFlags&fontShiftJIS){
Shift_JIS_MBCSdecoder mbd_sjis;
Shift_JIS_MBCSinterpreter mbi_sjis;

mbi_sjis.setDecoder(mbd_sjis);
s= mbi_sjis.decodeLine(s);
}


/*:110*/
#line 4403 "annoyance-filter.w"
;
strings.push(s);
}
}
}

/*:109*/
#line 4117 "annoyance-filter.w"
;
break;

case stagDefineEditText:
/*111:*/
#line 4436 "annoyance-filter.w"

{
#ifdef FLASH_PARSE_DEBUG
cout<<"Edit text record."<<endl;
#endif
get16();
rect rBounds;
getRect(&rBounds);

unsigned int flags= get16();

#ifdef FLASH_PARSE_DEBUG
cout<<"DefineEditText.  Flags = 0x"<<hex<<flags<<dec<<endl;
#endif

if(flags&seditTextFlagsHasFont){
#ifdef FLASH_PARSE_DEBUG
unsigned short uFontId= get16();
unsigned short uFontHeight= get16();
cout<<"FontId: "<<uFontId<<"  FontHeight: "<<uFontHeight<<endl;
#else
get16();
get16();
#endif
}

if(flags&seditTextFlagsHasTextColor){
skip8n(4);
}

if(flags&seditTextFlagsHasMaxLength){
#ifdef FLASH_PARSE_DEBUG
int iMaxLength= get16();
printf("length:%d ",iMaxLength);
#else
get16();
#endif
}

if(flags&seditTextFlagsHasLayout){
skip8n(1+(2*4));
}

string varname;
getString(varname);
if(!textOnly){
strings.push(varname);
}

if(flags&seditTextFlagsHasText){
string s;
char c;

while((c= get8())!=0){
s+= c;
}
strings.push(s);
}
}

/*:111*/
#line 4121 "annoyance-filter.w"
;
break;

case stagFrameLabel:
/*112:*/
#line 4501 "annoyance-filter.w"

{
string s;

getString(s);
if(!textOnly){
strings.push(s);
}
}

/*:112*/
#line 4125 "annoyance-filter.w"
;
break;

case stagDoAction:
/*113:*/
#line 4516 "annoyance-filter.w"

{
#ifdef FLASH_PARSE_DEBUG
cout<<"Do action:"<<endl;
#endif
actionCode ac;

while(isOK()&&(ac= static_cast<actionCode> (get8()))!=sactionNone){
unsigned int dlen= 0;
if((ac&0x80)!=0){
dlen= get16();
}

switch(ac){
case sactionGetURL:
{
string url,target;

getString(url);
getString(target);
if(!textOnly){
strings.push(url);
}
strings.push(target);
}
break;

default:
if(dlen> 0){
skip8n(dlen);
}
#ifdef FLASH_PARSE_DEBUG
cout<<"  Skipping action code 0x"<<hex<<ac<<dec<<
" data length "<<dlen<<endl;
#endif
break;
}
}
}

/*:113*/
#line 4129 "annoyance-filter.w"
;
break;

default:
#ifdef FLASH_PARSE_DEBUG
cout<<"nextString ignoring tag type "<<getTagType()<<" data length: "<<
getTagDataLength()<<endl;
#endif
ignoreTag();
break;
}
if(!strings.empty()){
goto haveStrings;
}
}
if(strings.empty()){
break;
}
}
return false;
}

/*:104*//*115:*/
#line 4616 "annoyance-filter.w"

#ifdef HAVE_PDF_DECODER
bool pdfTextExtractor::nextString(string&s){
if(!initialised){
initialised= true;

/*116:*/
#line 4645 "annoyance-filter.w"

#ifdef HAVE_MKSTEMP
strcpy(tempfn,"PDF_decode_XXXXXX");
mkstemp(tempfn);
#else
tmpnam(tempfn);
#endif
ofstream pdfstr(tempfn,ios::out|ios::binary);
if(!pdfstr){
cerr<<"Cannot create PDF temporary file "<<tempfn<<endl;
error= eof= true;
return false;
}
while(!isEOF()){
pdfstr<<get8();
}
pdfstr.close();

/*:116*/
#line 4622 "annoyance-filter.w"
;
/*117:*/
#line 4668 "annoyance-filter.w"

string pdfcmd= "pdftotext ";
pdfcmd+= tempfn;
pdfcmd+= " -";
ip= popen(pdfcmd.c_str(),"r");
if(ip==NULL){
cerr<<"Cannot open pipe to pdftotext."<<endl;
error= eof= true;
return false;
}
is.attach(fileno(ip));

/*:117*/
#line 4623 "annoyance-filter.w"
;
}

if(ip==NULL){
return false;
}

if(getline(is,s)!=NULL){
return true;
}
close();
return false;
}
#endif

/*:115*//*119:*/
#line 4894 "annoyance-filter.w"

bool mailFolder::nextLine(string&s){
while(true){
bool decoderEOF= false;

if(lookedAhead){
s= lookAheadLine;
lookedAhead= false;
}else{
if(mdp!=NULL){
if((asp!=NULL)?(!asp->nextString(s)):(!(mdp->getDecodedLine(s)))){
if(asp!=NULL){
asp->close();
asp= NULL;
}
s= mdp->getTerminatorSentinel();
decoderEOF= mdp->isEndOfFile();
if(decoderEOF){
s= "";
}
if(Annotate('d')){
ostringstream os;

os<<"Closing out "<<mdp->name()<<" decoder.  "<<mdp->getEncodedLineCount()<<" lines decoded.";
reportParserDiagnostic(os);
os.str("");
os<<"End sentinel: "<<s;
reportParserDiagnostic(os);
}
/*131:*/
#line 5289 "annoyance-filter.w"

mimeContentType= mimeContentTypeCharset= 
mimeContentTypeBoundary= mimeContentTransferEncoding= "";
mdp= NULL;
mbi= NULL;
asp= NULL;
byteStream= false;

/*:131*/
#line 4923 "annoyance-filter.w"
;
inPartHeader= 
!((s.substr(0,2)=="--")&&
(s.substr(2,partBoundary.length())==partBoundary)&&
(s.substr(partBoundary.length()+2,2)=="--"));
if((!inPartHeader)&&(!(partBoundaryStack.empty()))){
partBoundary= partBoundaryStack.top();
partBoundaryStack.pop();
}
}
}else{
if(!getline(*is,s)){
/*127:*/
#line 5194 "annoyance-filter.w"

#ifdef HAVE_DIRECTORY_TRAVERSAL
if(dirFolder){
if(ip!=NULL){
pclose(ip);
ip= NULL;
}else{
ifdir.close();
}
if(findNextFileInDirectory(cfName)){
continue;
}
}
#endif


/*:127*/
#line 4935 "annoyance-filter.w"
;
return false;
}
}
}
nLines++;
if((mdp==NULL)&&(tlist!=NULL)&&(!decoderEOF)){
tlist->push_back(s);
}
/*128:*/
#line 5222 "annoyance-filter.w"

if(s.substr(0,(sizeof messageSentinel)-1)==messageSentinel){
nMessages++;
newMessage= true;
inHeader= true;
multiPart= false;
inPartHeader= false;
partHeaderLines= 0;
bodyContentType= bodyContentTypeCharset= bodyContentTransferEncoding= "";
while(!partBoundaryStack.empty()){
ostringstream os;

os<<"Orphaned part boundary on stack: \""<<partBoundaryStack.top()<<"\"";
reportParserDiagnostic(os);
partBoundaryStack.pop();
}
/*131:*/
#line 5289 "annoyance-filter.w"

mimeContentType= mimeContentTypeCharset= 
mimeContentTypeBoundary= mimeContentTransferEncoding= "";
mdp= NULL;
mbi= NULL;
asp= NULL;
byteStream= false;

/*:131*/
#line 5238 "annoyance-filter.w"
;
}else{
newMessage= false;
}

/*:128*/
#line 4944 "annoyance-filter.w"
;
/*129:*/
#line 5248 "annoyance-filter.w"

while((s.length()> 0)&&(isISOspace(s[s.length()-1]))){
s.erase(s.length()-1);
}

/*:129*/
#line 4945 "annoyance-filter.w"
;
/*130:*/
#line 5263 "annoyance-filter.w"

if(inHeader||inPartHeader){
if(s==""){
if(inHeader){
if((!multiPart)&&(bodyContentTransferEncoding!="")){
mimeContentType= bodyContentType;
mimeContentTypeCharset= bodyContentTypeCharset;
mimeContentTransferEncoding= bodyContentTransferEncoding;
multiPart= true;
partBoundary= "";
}
}
inHeader= inPartHeader= false;
/*140:*/
#line 5563 "annoyance-filter.w"

if(multiPart){
assert(mdp==NULL);

#ifdef TYPE_LOG





typeLog<<mimeContentType<<"\t"<<
mimeContentTypeCharset<<"\t"<<
mimeContentTransferEncoding<<endl;
#endif

/*141:*/
#line 5598 "annoyance-filter.w"

if(mimeContentType=="multipart/alternative"){
if(mimeContentTypeBoundary!=""){
partBoundaryStack.push(partBoundary);
partBoundary= mimeContentTypeBoundary;
}else{
if(Annotate('d')){
ostringstream os;

os<<"Boundary missing from Content-Type of multipart/alternative.";
reportParserDiagnostic(os);
}
}
}

/*:141*/
#line 5578 "annoyance-filter.w"
;

/*142:*/
#line 5618 "annoyance-filter.w"

#ifdef HAVE_PDF_DECODER
if(mimeContentType=="application/pdf"){
asp= &aspPdf;
}else
#endif
if((mimeContentType=="application/x-shockwave-flash")||
(mimeContentType=="image/vnd.rn-realflash")){
asp= &aspFlash;
}
if(asp!=NULL){
asp->setMailFolder(this);
if(Annotate('d')){
ostringstream os;

os<<"Activating "<<asp->name()<<" application file decoder.";
reportParserDiagnostic(os);
}
}

/*:142*/
#line 5580 "annoyance-filter.w"
;

/*143:*/
#line 5647 "annoyance-filter.w"

if((asp==NULL)&&(streamMinTokenLength> 0)&&
(mimeContentType.substr(0,12)=="application/")){
if(Annotate('d')){
ostringstream os;

os<<"Activating byte stream parser for \""<<mimeContentType<<"\"";
reportParserDiagnostic(os);
}
byteStream= true;
}
/*:143*/
#line 5582 "annoyance-filter.w"
;

/*144:*/
#line 5668 "annoyance-filter.w"

if(Annotate('d')){
ostringstream os;

reportParserDiagnostic("");
os<<"mimeContentType: {"<<mimeContentType<<"}";
reportParserDiagnostic(os);
os.str("");
os<<"mimeContentTypeCharset: {"<<mimeContentTypeCharset<<"}";
reportParserDiagnostic(os);
os.str("");
os<<"mimeContentTransferEncoding: {"<<mimeContentTransferEncoding<<"}";
reportParserDiagnostic(os);
}

if((asp==NULL)&&
(mimeContentType.substr(0,6)=="image/")||
(mimeContentType.substr(0,6)=="video/")
){
smd.set(is,this,partBoundary,tlist);
mdp= &smd;
if(Annotate('d')){
ostringstream os;

os<<"Activating MIME sink decoder with sentinel: \""<<partBoundary<<
"\" due to Content-Type = "<<mimeContentType;
reportParserDiagnostic(os);
}
if(dlist){
dlist->push_back(Xfile+"-Decoder: Sink");
}
}

/*:144*/
#line 5584 "annoyance-filter.w"


/*145:*/
#line 5708 "annoyance-filter.w"

else if(byteStream||(asp!=NULL)||
(mimeContentType=="plain/txt")||
(mimeContentType.substr(0,5)=="text/")||
(mimeContentType=="message/rfc822")){

/*146:*/
#line 5731 "annoyance-filter.w"

bool gibberish= false;

if(mimeContentTypeCharset.substr(0,6)=="gb2312"){
mbi_gb2312.setDecoder(mbd_euc);
mbi= &mbi_gb2312;
}

if(mimeContentTypeCharset=="big5"){
mbi_big5.setDecoder(mbd_big5);
mbi= &mbi_big5;
}

if(mimeContentTypeCharset=="utf-8"){
mbi_unicode.setDecoder(mbd_utf_8);
mbi= &mbi_unicode;
}

if(mimeContentTypeCharset=="euc-kr"){
mbi_kr.setDecoder(mbd_euc);
mbi= &mbi_kr;
}

#ifdef CHECK_FOR_GIBBERISH_CHARACTER_SETS
if((mimeContentTypeCharset.length()==0)||
(mimeContentTypeCharset=="us-ascii")||
(mimeContentTypeCharset.substr(0,8)=="iso-8859")||
(mimeContentTypeCharset=="windows-1251")){
if(Annotate('d')){
ostringstream os;

os<<"Accepting part in Content-Type-Charset: "<<mimeContentTypeCharset<<"  ("<<
mimeContentType<<" "<<mimeContentTransferEncoding<<")";
reportParserDiagnostic(os);
}
}else{
if(Annotate('d')){
ostringstream os;

os<<"Rejecting part in Content-Type-Charset: "<<mimeContentTypeCharset<<"  ("<<
mimeContentType<<" "<<mimeContentTransferEncoding<<")";
reportParserDiagnostic(os);
}
gibberish= true;
}
#endif

/*:146*/
#line 5714 "annoyance-filter.w"
;

/*147:*/
#line 5791 "annoyance-filter.w"

if(!gibberish){
if((mimeContentTransferEncoding.length()==0)||
(mimeContentTransferEncoding.substr(0,4)=="7bit")||
(mimeContentTransferEncoding.substr(0,4)=="8bit")||
(mimeContentTransferEncoding=="ascii")){
imd.set(is,this,partBoundary,tlist);
mdp= &imd;
}else if(mimeContentTransferEncoding=="base64"){
bmd.set(is,this,partBoundary,tlist);
mdp= &bmd;
}else if(mimeContentTransferEncoding=="quoted-printable"){
qmd.set(is,this,partBoundary,tlist);
mdp= &qmd;
}else{
gibberish= true;
smd.set(is,this,partBoundary,tlist);
mdp= &smd;
}

assert(mdp!=NULL);
if(Annotate('d')){
ostringstream os;

os<<(gibberish?"Rejecting":"Accepting")<<
" part in Content-Transfer-Encoding: "<<mimeContentTransferEncoding<<"  ("<<
mimeContentTypeCharset<<" "<<mimeContentType<<")";
reportParserDiagnostic(os);
}
if(dlist){
dlist->push_back(Xfile+"-Decoder: "+mdp->name());
}
if(Annotate('d')){
ostringstream os;

os<<"Activating MIME "<<mdp->name()<<" decoder with sentinel: "<<partBoundary;
reportParserDiagnostic(os);
}
}

/*:147*/
#line 5716 "annoyance-filter.w"
;

/*148:*/
#line 5836 "annoyance-filter.w"

if(byteStream&&(mdp==NULL)){
if(Annotate('d')){
ostringstream os;

os<<"Canceling byte stream mode due to Content-Transfer-Encoding: {"<<
mimeContentTransferEncoding<<"}  ("<<
mimeContentTypeCharset<<" "<<mimeContentType<<")";
reportParserDiagnostic(os);
}
byteStream= false;
}

/*:148*/
#line 5718 "annoyance-filter.w"
;
}

/*:145*/
#line 5586 "annoyance-filter.w"
;
}

/*:140*/
#line 5276 "annoyance-filter.w"
;
}
/*132:*/
#line 5311 "annoyance-filter.w"

/*133:*/
#line 5359 "annoyance-filter.w"

bool isSpoofedHeader= false;
if(inHeader){
string sc= s,scx= Xfile;

stringCanonicalise(sc);
stringCanonicalise(scx);
scx+= '-';
if(sc.substr(0,scx.length())==scx){
if(tlist!=NULL){
tlist->pop_back();
}
isSpoofedHeader= true;
}
}

/*:133*/
#line 5312 "annoyance-filter.w"
;

while((inHeader||inPartHeader)&&getline(*is,lookAheadLine)!=NULL){
string lal= lookAheadLine;

while((lookAheadLine.length()> 0)&&(isISOspace(lookAheadLine[lookAheadLine.length()-1]))){
lookAheadLine.erase(lookAheadLine.length()-1);
}
if((lookAheadLine.length()> 0)&&isISOspace(lookAheadLine[0])){
string::size_type p= 1;
while(isISOspace(lookAheadLine[p])){
p++;
}
s+= lookAheadLine.substr(p);
if((tlist!=NULL)&&(!isSpoofedHeader)){
tlist->push_back(lal);
}
continue;
}
lookedAhead= true;
lookAheadLine= lal;
break;
}
if(isSpoofedHeader){
ostringstream os;

os<<"Spoofed header rejected: "<<s;
reportParserDiagnostic(os.str());
continue;
}

/*:132*/
#line 5278 "annoyance-filter.w"
;

/*137:*/
#line 5501 "annoyance-filter.w"

string::size_type p,p1;
string arg;

if(inHeader&&compareHeaderField(s,"content-type",arg)){
string sc= s;
stringCanonicalise(sc);
if((p= sc.find("multipart/",13))!=string::npos){
if((p= sc.find("boundary=",p+10))!=string::npos){
if(s[p+9]=='\"'){
p1= sc.find("\"",p+10);
p+= 10;
}else{
p+= 9;
p1= sc.length()-p;
}
multiPart= true;
partBoundary= s.substr(p,(p1-p));
if(Annotate('d')){
ostringstream os;

os<<"Multi-part boundary: \""<<partBoundary<<"\"";
reportParserDiagnostic(os);
}
}
}
}

/*:137*/
#line 5280 "annoyance-filter.w"
;
/*134:*/
#line 5385 "annoyance-filter.w"

{
string arg,par;

if(compareHeaderField(s,"content-type",arg)){
if(parseHeaderArgument(s,"charset",par)){
stringCanonicalise(par);
bodyContentTypeCharset= par;
}
bodyContentType= arg;
}
if(inHeader&&compareHeaderField(s,"content-transfer-encoding",arg)){
bodyContentTransferEncoding= arg;
}
}

/*:134*/
#line 5281 "annoyance-filter.w"
;
/*135:*/
#line 5413 "annoyance-filter.w"

if(inHeader){
string sc= s;
string::size_type p,p1,p2,p3,p4;
char etype;
unsigned int ndecodes= 0;
string charset;

stringCanonicalise(sc);
p4= 0;
while(((p= sc.find("=?",p4))!=string::npos)){
p4= p+2;
if(((p1= sc.find("?q?",p4))!=string::npos)||
((p1= sc.find("?b?",p4))!=string::npos)){
charset= sc.substr(p4,p1-p4);
etype= sc[p1+1];
p4= p1+3;
if((p2= sc.find("?=",p4))!=string::npos){
p1+= 3;
p3= p2-p1;
string drt;
if(etype=='q'){
drt= quotedPrintableMIMEdecoder::decodeEscapedText(sc.substr(p1,p3),this);
}else{
assert(etype=='b');
drt= base64MIMEdecoder::decodeEscapedText(sc.substr(p1,p3),this);
}
/*136:*/
#line 5460 "annoyance-filter.w"

if(charset.substr(0,6)=="gb2312"){
EUC_MBCSdecoder mbd_euc;
GB2312_MBCSinterpreter mbi_gb2312;

mbi_gb2312.setDecoder(mbd_euc);
drt= mbi_gb2312.decodeLine(drt);
}else if(charset=="big5"){
Big5_MBCSdecoder mbd_big5;
Big5_MBCSinterpreter mbi_big5;

mbi_big5.setDecoder(mbd_big5);
drt= mbi_big5.decodeLine(drt);
}else if(charset=="utf-8"){
UTF_8_Unicode_MBCSdecoder mbd_utf_8;
Unicode_MBCSinterpreter mbi_unicode;

mbi_unicode.setDecoder(mbd_utf_8);
drt= mbi_unicode.decodeLine(drt);
}else if(charset=="euc-kr"){
EUC_MBCSdecoder mbd_euc;
KR_MBCSinterpreter mbi_kr;

mbi_kr.setDecoder(mbd_euc);
drt= mbi_kr.decodeLine(drt);
}else if(charset.substr(0,8)=="iso-8859"){

}else{
ostringstream os;

os<<"Subject line: no interpreter for ("<<charset<<") character set.";
reportParserDiagnostic(os.str());
}

/*:136*/
#line 5440 "annoyance-filter.w"
;
sc.replace(p,(p2-p)+2,drt);
p4= p+drt.length();
ndecodes++;
}
}
}
if(ndecodes> 0){
s= sc;
}
}

/*:135*/
#line 5282 "annoyance-filter.w"
;
}

/*:130*/
#line 4946 "annoyance-filter.w"
;
/*152:*/
#line 5960 "annoyance-filter.w"

if(multiPart&&inPartHeader){
string arg,par;

partHeaderLines++;
if(compareHeaderField(s,"content-type",arg)){
if(parseHeaderArgument(s,"charset",par)){
stringCanonicalise(par);
mimeContentTypeCharset= par;
}
if(parseHeaderArgument(s,"boundary",par)){
mimeContentTypeBoundary= par;
}
mimeContentType= arg;
}

if(compareHeaderField(s,"content-transfer-encoding",arg)){
mimeContentTransferEncoding= arg;
}
}


/*:152*/
#line 4947 "annoyance-filter.w"
;

/*138:*/
#line 5536 "annoyance-filter.w"

if(multiPart&&(!inHeader)&&
(partBoundary!="")&&
(s.substr(0,2)=="--")&&
(s.substr(2,partBoundary.length())==partBoundary)&&
(s.substr(partBoundary.length()+2)!="--")){
inPartHeader= true;
mimeContentType= mimeContentTypeCharset= mimeContentTypeBoundary= 
mimeContentTransferEncoding= "";
}

/*:138*/
#line 4949 "annoyance-filter.w"
;
/*139:*/
#line 5552 "annoyance-filter.w"

if((mbi!=NULL)&&(!inHeader)&&(!inPartHeader)){
s= mbi->decodeLine(s);
}

/*:139*/
#line 4950 "annoyance-filter.w"
;
return true;
}
}


/*:119*//*120:*/
#line 4965 "annoyance-filter.w"

int mailFolder::nextByte(void){
assert(mdp!=NULL);
int c= mdp->getDecodedChar();
if(c<0){
byteStream= false;
if(Annotate('d')){
ostringstream os;

os<<"End of byte stream.  Deactivating byte stream parser.";
reportParserDiagnostic(os);
}
}
return c;
}

/*:120*//*125:*/
#line 5112 "annoyance-filter.w"

#ifdef HAVE_DIRECTORY_TRAVERSAL
bool mailFolder::findNextFileInDirectory(string&fname){
assert(dirFolder);

if(dh==NULL){
return false;
}

while(true){
struct dirent*de;
struct stat fs;

de= readdir(dh);
if(de==NULL){
closedir(dh);
dh= NULL;
return false;
}
cfName= dirName+pathSeparator+de->d_name;
if(stat(cfName.c_str(),&fs)==0){
if(S_ISREG(fs.st_mode)){
fname= cfName;
return openNextFileInDirectory();
}
}else{
if(verbose){
cerr<<"Cannot get status of "<<cfName<<".  Skipping."<<endl;
}
}
}
}
#endif

/*:125*//*126:*/
#line 5152 "annoyance-filter.w"

#ifdef HAVE_DIRECTORY_TRAVERSAL
bool mailFolder::openNextFileInDirectory(void){
assert(dirFolder);

if(dh==NULL){
return false;
}

#ifdef COMPRESSED_FILES
string fname= cfName;
/*122:*/
#line 5032 "annoyance-filter.w"

#ifdef HAVE_READLINK
int maxSlinks= 50;

string jname= fname;
char slbuf[1024];
while(maxSlinks--> 0){
int sll= readlink(jname.c_str(),slbuf,(sizeof slbuf)-1);
if(sll>=0){
assert(sll<static_cast<int> (sizeof slbuf));
slbuf[sll]= 0;
jname= slbuf;
}else{
break;
}
}
if(maxSlinks<=0){
cerr<<"Warning: probable symbolic link loop for \""<<
fname<<"\""<<endl;
}
#endif

/*:122*/
#line 5163 "annoyance-filter.w"
;

if(jname.rfind(Compressed_file_type)!=string::npos){
string cmd(Uncompress_command);
cmd+= ' '+fname;
ip= popen(cmd.c_str(),"r");
ifdir.attach(fileno(ip));
ifdir.clear();
}else{
#endif
ifdir.open(cfName.c_str());
if(!ifdir.is_open()){
if(verbose){
cerr<<"Unable to open mail folder directory file \""<<
cfName<<"\""<<endl;
}
return false;
}
#ifdef COMPRESSED_FILES
}
#endif
is= &ifdir;
return true;
}
#endif

/*:126*//*149:*/
#line 5852 "annoyance-filter.w"

void mailFolder::stringCanonicalise(string&s)
{
for(unsigned int i= 0;i<s.length();i++){
if(isISOupper(s[i])){
s[i]= toISOlower(s[i]);
}
}
}

/*:149*//*150:*/
#line 5868 "annoyance-filter.w"

bool mailFolder::compareHeaderField(string&s,const string target,string&arg)
{
if(s.length()> target.length()){
string sc= s;

stringCanonicalise(sc);
if((sc.substr(0,target.length())==target)&&
(sc[target.length()]==':')){
unsigned int i;

for(i= target.length()+1;i<sc.length();i++){
if(!isISOspace(sc[i])){
break;
}
}
if(i<sc.length()){
int n= 0;

while((i+n)<sc.length()){
if(isISOspace(sc[i+n])||(sc[i+n]==';')){
break;
}
n++;
}
arg= sc.substr(i,n);
}else{
arg= "";
}
return true;
}
}
return false;
}

/*:150*//*151:*/
#line 5909 "annoyance-filter.w"

bool mailFolder::parseHeaderArgument(string&s,const string target,string&arg)
{
if(s.length()> target.length()){
string sc= s;
string::size_type p,p1;

stringCanonicalise(sc);
if(((p= sc.find(target))!=string::npos)&&
(sc.length()> (p+target.length()))&&
(sc[p+target.length()]=='=')){
p+= target.length()+1;
if(p<s.length()){
if(s[p]=='"'){
if((p1= s.find('"',p+1))!=string::npos){
arg= s.substr(p+1,p1-(p+1));
return true;
}
}else{
string::size_type i= p;

for(;i<s.length();i++){
if(!isISOspace(s[i])){
break;
}
}
if(i<s.length()){
int n= 0;

while((i+n)<s.length()){
if((isISOspace(s[i+n]))||(s[i+n]==';')){
break;
}
n++;
}
arg= s.substr(i,n);
}else{
arg= "";
}
return true;
}
}
}
}
return false;
}

/*:151*//*153:*/
#line 5987 "annoyance-filter.w"


void mailFolder::writeMessageTranscript(ostream&os= cout){
assert(tlist!=NULL);
unsigned int n= tlist->size();
if((n> 1)&&
(tlist->back().substr(0,(sizeof messageSentinel)-1)==messageSentinel)){
n--;
}
list<string> ::iterator p= tlist->begin();
for(unsigned int i= 0;i<n;i++){
os<<*p++<<endl;
}
}

void mailFolder::writeMessageTranscript(const string fname= "-"){
if(fname!="-"){
ofstream of(fname.c_str());
writeMessageTranscript(of);
of.close();
}else{
writeMessageTranscript(cout);
}
}

/*:153*//*154:*/
#line 6022 "annoyance-filter.w"

void mailFolder::reportParserDiagnostic(const string s)const{
if(verbose){
cerr<<s<<endl;
}
if(Annotate('p')||Annotate('d')){
parserDiagnostics.push(s);
}
}

void mailFolder::reportParserDiagnostic(const ostringstream&os)const{
reportParserDiagnostic(os.str());
}

/*:154*//*156:*/
#line 6142 "annoyance-filter.w"

void tokenDefinition::setISO_8859defaults(unsigned int lmin= 0,unsigned int lmax= 0){
clear();
setLengthLimits(lmin,lmax);
for(unsigned int c= 0;c<256;c++){
isToken[c]= (isascii(c)&&isdigit(c))||isISOalpha(c)||
(c=='-')||(c=='\'')||(c=='$');
notExclusively[c]= (isdigit(c)||(c=='-'))?1:0;
}
notAtEnd['-']= notAtEnd['\'']= true;
}


/*:156*//*157:*/
#line 6160 "annoyance-filter.w"

void tokenDefinition::setUS_ASCIIdefaults(unsigned int lmin= 0,unsigned int lmax= 0){
clear();
setLengthLimits(lmin,lmax);
for(unsigned int c= 0;c<128;c++){
isToken[c]= isalpha(c)||isdigit(c);
notExclusively[c]= (isdigit(c)||(c=='-'))?1:0;
}
isToken['_']= notExclusively['_']= true;
notAtEnd['-']= notAtEnd['\'']= true;
}


/*:157*//*159:*/
#line 6296 "annoyance-filter.w"

bool tokenParser::nextToken(dictionaryWord&d){
string token;

while(!atEnd){

/*160:*/
#line 6396 "annoyance-filter.w"

if(!pendingPhrases.empty()){
token= pendingPhrases.front();
pendingPhrases.pop_front();
d.set(token);
d.toLower();
if(pTokenTrace&&saveMessage){
messageQueue.push_back(string("  \"")+d.text+"\"");
}
return true;
}

/*:160*/
#line 6302 "annoyance-filter.w"
;

token= "";
string::size_type necount= 0;

if(source->isByteStream()){
/*163:*/
#line 6516 "annoyance-filter.w"

int b;

while((b= source->nextByte())>=0){


if(!(btd->isTokenMember(b))){
continue;
}



if(btd->isTokenNotAtEnd(b)){
continue;
}



if(btd->isTokenNotExclusively(b)){
necount++;
}

token+= static_cast<char> (b);
while(((b= source->nextByte())>=0)&&
btd->isTokenMember(b)
){
if(btd->isTokenNotExclusively(b)){
necount++;
}
token+= static_cast<char> (b);
}


while((token.length()> 0)&&
btd->isTokenNotAtEnd(ChIx(token[token.length()-1]))
){
token.erase(token.length()-1);
}



if(!(btd->isTokenLengthAcceptable(token))){
token= "";
continue;
}



if(necount==token.length()){
token= "";
continue;
}
d.set(token);
d.toLower();
/*165:*/
#line 6613 "annoyance-filter.w"

if(assemblePhrases){
assembleAllPhrases(d);
continue;
}

/*:165*/
#line 6570 "annoyance-filter.w"
;
if(pTokenTrace&&saveMessage){
messageQueue.push_back(string("  \"")+d.text+"\"");
}
return true;
}
continue;

/*:163*/
#line 6308 "annoyance-filter.w"
;
}


while((clp<cl.length())&&
(inHTMLcomment||
(!(td->isTokenMember(ChIx(cl[clp]))))
)){
/*161:*/
#line 6421 "annoyance-filter.w"

if(inHTML&&!inHTMLcomment&&(cl.substr(clp,4)==HTMLCommentBegin)){
inHTMLcomment= true;
clp+= 4;
#ifdef HTML_COMMENT_DEBUG
cout<<"------------------------------ HTML Comment begin: "<<cl<<endl;
#endif
continue;
}
if(inHTML&&inHTMLcomment&&(cl.substr(clp,3)==HTMLCommentEnd)){
inHTMLcomment= false;
clp+= 3;
#ifdef HTML_COMMENT_DEBUG
cout<<"------------------------------ HTML Comment end: "<<cl<<endl;
#endif
continue;
}
#ifdef HTML_COMMENT_DEBUG
if(inHTMLcomment){
cout<<cl[clp];
if(clp==(cl.length()-1)){
cout<<endl;
}
}
#endif

/*:161*/
#line 6316 "annoyance-filter.w"
;
/*162:*/
#line 6455 "annoyance-filter.w"

if(cl[clp]=='<'&&(clp<=(cl.length()-6))){
if((cl[clp+1]=='H'||cl[clp+1]=='h')&&
(cl[clp+5]=='>'||cl[clp+5]==' ')){
string tag;
for(int i= 1;i<5;i++){
tag+= (islower(cl[clp+i]))?toupper(cl[clp+i]):cl[clp+i];
}
if(tag=="HTML"){
inHTML= true;
#ifdef HTML_COMMENT_DEBUG
cout<<"------------------------------ In HTML: "<<cl<<endl;
#endif
}
}
}

if(cl[clp]=='<'&&(clp<=(cl.length()-7))){
if((cl[clp+1]=='/')&&(cl[clp+2]=='H'||cl[clp+2]=='h')&&
(cl[clp+6]=='>')){
string tag;
for(int i= 2;i<6;i++){
tag+= (islower(cl[clp+i]))?toupper(cl[clp+i]):cl[clp+i];
}
if(tag=="HTML"){
inHTML= false;
#ifdef HTML_COMMENT_DEBUG
cout<<"------------------------------ Out of HTML: "<<cl<<endl;
#endif
}
}
}

/*:162*/
#line 6317 "annoyance-filter.w"
;
clp++;
}


if(clp>=cl.length()){
nextLine();
continue;
}


if(td->isTokenNotAtEnd(ChIx(cl[clp]))){
clp++;
continue;
}



if(td->isTokenNotExclusively(ChIx(cl[clp]))){
necount++;
}
token+= cl[clp++];
while((clp<cl.length())){
if((!inHTMLcomment)&&(td->isTokenMember(ChIx(cl[clp])))){
if(td->isTokenNotExclusively(ChIx(cl[clp]))){
necount++;
}
token+= cl[clp++];
}else{
/*161:*/
#line 6421 "annoyance-filter.w"

if(inHTML&&!inHTMLcomment&&(cl.substr(clp,4)==HTMLCommentBegin)){
inHTMLcomment= true;
clp+= 4;
#ifdef HTML_COMMENT_DEBUG
cout<<"------------------------------ HTML Comment begin: "<<cl<<endl;
#endif
continue;
}
if(inHTML&&inHTMLcomment&&(cl.substr(clp,3)==HTMLCommentEnd)){
inHTMLcomment= false;
clp+= 3;
#ifdef HTML_COMMENT_DEBUG
cout<<"------------------------------ HTML Comment end: "<<cl<<endl;
#endif
continue;
}
#ifdef HTML_COMMENT_DEBUG
if(inHTMLcomment){
cout<<cl[clp];
if(clp==(cl.length()-1)){
cout<<endl;
}
}
#endif

/*:161*/
#line 6346 "annoyance-filter.w"
;
if(inHTMLcomment){
clp++;
continue;
}
break;
}
}


while((token.length()> 0)&&
td->isTokenNotAtEnd(ChIx(token[token.length()-1]))
){
token.erase(token.length()-1);
}



if(!(td->isTokenLengthAcceptable(token))){
continue;
}









if(necount==token.length()){
continue;
}

d.set(token);
d.toLower();
/*165:*/
#line 6613 "annoyance-filter.w"

if(assemblePhrases){
assembleAllPhrases(d);
continue;
}

/*:165*/
#line 6382 "annoyance-filter.w"
;
if(pTokenTrace&&saveMessage){
messageQueue.push_back(string("  \"")+d.text+"\"");
}
return true;
}
return false;
}

/*:159*//*166:*/
#line 6629 "annoyance-filter.w"

void tokenParser::assembleAllPhrases(dictionaryWord&d){
phraseQueue.push_back(d.text);
if(phraseQueue.size()> phraseMax){
phraseQueue.pop_front();
assert(phraseQueue.size()==phraseMax);
}

for(unsigned int p= phraseMin;p<=phraseMax;p++){
if(p<=phraseQueue.size()){
deque<string> ::const_reverse_iterator wp= phraseQueue.rbegin();
string phrase= "";
for(unsigned int i= 0;i<p;i++){

phrase= (*wp)+((phrase=="")?"":" ")+phrase;
wp++;
}
if((phraseLimit==0)||(phrase.length()<=phraseLimit)){
pendingPhrases.push_back(phrase);
}
}
}
}

/*:166*//*170:*/
#line 6759 "annoyance-filter.w"

double classifyMessage::classifyThis(void){
dictionaryWord dw;
double junkProb= -1;

if(transcriptFilename!=""){
mf->setTranscriptList(&messageTranscript);
if(Annotate('p')||Annotate('d')){
saveParserDiagnostics= true;
}
}

/*172:*/
#line 6807 "annoyance-filter.w"

set<string> utokens;

while(tp.nextToken(dw)){
utokens.insert(dw.get());
}

/*:172*/
#line 6771 "annoyance-filter.w"
;

/*173:*/
#line 6835 "annoyance-filter.w"

multimap<double,string> rtokens;

for(set<string> ::iterator t= utokens.begin();t!=utokens.end();t++){
double pdiff;
dictionary::iterator dp;

if(((dp= d->find(*t))!=d->end())&&
(dp->second.getJunkProbability()>=0)){
pdiff= abs(dp->second.getJunkProbability()-0.5);
}else{
pdiff= abs(unknownWordProbability-0.5);
}

rtokens.insert(make_pair(pdiff,*t));
}

/*:173*/
#line 6773 "annoyance-filter.w"
;

/*174:*/
#line 6861 "annoyance-filter.w"

unsigned int n= min(static_cast<multimap<double,string> ::size_type> (nExtremal),rtokens.size());
multimap<double,string> ::const_reverse_iterator rp= rtokens.rbegin();
double probP= 1,probQ= 1;
if(verbose){
cerr<<"Rank   Probability   Token"<<endl;
}

for(unsigned int i= 0;i<n;i++){
dictionary::iterator dp= d->find(rp->second);
double p= ((dp==d->end())||(dp->second.getJunkProbability()<0))?
unknownWordProbability:dp->second.getJunkProbability();

if(verbose){
cerr<<setw(3)<<setiosflags(ios::right)<<(i+1)<<"      "<<
setw(9)<<setprecision(5)<<setiosflags(ios::left)<<p<<
"  "<<rp->second<<endl;
}
probP*= p;
probQ*= (1-p);
rp++;
}
junkProb= probP/(probP+probQ);
if(verbose){
cerr<<"ProbP = "<<probP<<", ProbQ = "<<probQ<<endl;
}

/*:174*/
#line 6775 "annoyance-filter.w"
;

if(tp.getSaveMessage()){
/*175:*/
#line 6894 "annoyance-filter.w"

ostringstream os;
list<string> ::iterator p;




for(p= tp.messageQueue.begin();p!=tp.messageQueue.end();p++){
if(p->length()==0){
break;
}
}

os<<Xfile<<"-Junk-Probability: "<<setprecision(5)<<junkProb;
tp.messageQueue.insert(p,os.str());
os.str("");

addSignificantWordDiagnostics(messageTranscript,p,rtokens);

/*:175*/
#line 6778 "annoyance-filter.w"
;
ofstream mdump(pDiagFilename.c_str());
tp.writeMessageQueue(mdump);
mdump.close();
}

if(transcriptFilename!=""){
/*176:*/
#line 6920 "annoyance-filter.w"

ostringstream os;
list<string> ::iterator p;




for(p= messageTranscript.begin();p!=messageTranscript.end();p++){
if(p->length()==0){
break;
}
}

double jp= junkProb;



if(jp<0.001){
jp= 0;
}
os<<Xfile<<"-Junk-Probability: "<<setprecision(3)<<jp;
messageTranscript.insert(p,os.str());
os.str("");
os<<Xfile<<"-Classification: ";
if(junkProb>=junkThreshold){
os<<"Junk";
}else if(junkProb<=mailThreshold){
os<<"Mail";
}else{
os<<"Indeterminate";
}
messageTranscript.insert(p,os.str());

if(Annotate('w')){
addSignificantWordDiagnostics(messageTranscript,p,rtokens);
}

if(Annotate('p')||Annotate('d')){
while(!parserDiagnostics.empty()){
ostringstream os;

os<<Xfile<<"-Parser-Diagnostic: "<<parserDiagnostics.front();
messageTranscript.insert(p,os.str());
parserDiagnostics.pop();
}
}

/*:176*/
#line 6785 "annoyance-filter.w"
;
mf->writeMessageTranscript(transcriptFilename);
}

return junkProb;
}

/*:170*//*177:*/
#line 6973 "annoyance-filter.w"

void classifyMessage::addSignificantWordDiagnostics(list<string> &l,
list<string> ::iterator where,
multimap<double,string> &rtokens){
unsigned int n= min(static_cast<multimap<double,string> ::size_type> (nExtremal),rtokens.size());
multimap<double,string> ::const_reverse_iterator rp= rtokens.rbegin();

for(unsigned int i= 0;i<n;i++){
dictionary::iterator dp= d->find(rp->second);
double wp= ((dp==d->end())||((dp->second.getJunkProbability()<0)))?
unknownWordProbability:dp->second.getJunkProbability();
ostringstream os;

os<<Xfile<<"-Significant-Word: "<<
setw(3)<<setiosflags(ios::right)<<(i+1)<<"  "<<
setw(8)<<setprecision(5)<<setiosflags(ios::left)<<wp<<
"  \""<<rp->second<<"\"";
l.insert(where,os.str());
os.str("");
rp++;
}
}

/*:177*/
#line 7822 "annoyance-filter.w"

/*180:*/
#line 7028 "annoyance-filter.w"

static dictionary dict;

/*:180*//*199:*/
#line 7739 "annoyance-filter.w"

static tokenDefinition isoToken;
static tokenDefinition asciiToken;

/*:199*/
#line 7823 "annoyance-filter.w"

/*169:*/
#line 6737 "annoyance-filter.w"

classifyMessage::classifyMessage(mailFolder&m,
dictionary&dt,
unsigned int nExt= 15,double uwp= 0.2){
mf= &m;
tp.setSource(m);
tp.setTokenDefinition(isoToken,asciiToken);
tp.setTokenLengthLimits(maxTokenLength,minTokenLength,
streamMaxTokenLength,streamMinTokenLength);
if(pDiagFilename.length()> 0){
tp.setSaveMessage(true);
}
d= &dt;
nExtremal= nExt;
unknownWordProbability= uwp;
}

/*:169*//*183:*/
#line 7087 "annoyance-filter.w"

static void updateProbability(void)
{
dict.computeJunkProbability(messageCount[dictionaryWord::Mail],messageCount[dictionaryWord::Junk],
mailBias,minOccurrences);
singleDictionaryRead= false;
}

/*:183*//*184:*/
#line 7099 "annoyance-filter.w"

static void printDictionary(ostream&os= cout)
{
updateProbability();
os<<"Dictionary contains "<<dict.size()<<" unique tokens."<<endl;
for(dictionary::iterator dp= dict.begin();dp!=dict.end();dp++){
dp->second.describe(os);
}
}

/*:184*//*185:*/
#line 7113 "annoyance-filter.w"

static double classifyMessages(const char*fname)
{
double jp;

if(dict.empty()){
cerr<<"You cannot --classify or --test a message "
"unless you have first loaded a dictionary."<<endl;
jp= 0.5;
}else{
mailFolder mf(fname,dictionaryWord::Mail);

classifyMessage cm(mf,dict,significantWords,novelWordProbability);

jp= cm.classifyThis();
if(verbose){
cerr<<"Message junk probability: "<<setprecision(5)<<jp<<endl;
}
}
nTested++;
return jp;
}

/*:185*//*195:*/
#line 7298 "annoyance-filter.w"

static void usage(void)
{
cout<<PRODUCT<<"  --  Annoyance Filter.  Call"<<endl;
cout<<"                      with "<<PRODUCT<<" [options]"<<endl;
cout<<""<<endl;
cout<<"Options:"<<endl;
cout<<"    --annotate options     Specify optional annotations in --transcript"<<endl;
cout<<"    --binword n            Scan binary streams for words >= n characters (0 = none)"<<endl;
cout<<"    --classify fname       Classify first message in fname"<<endl;
cout<<"    --clearjunk            Clear junk counts in dictionary"<<endl;
cout<<"    --clearmail            Clear mail counts in dictionary"<<endl;
cout<<"    --copyright            Print copyright information"<<endl;
cout<<"    --csvread fname        Import dictionary from fname in CSV format"<<endl;
cout<<"    --csvwrite fname       Export dictionary to fname in CSV format"<<endl;
cout<<"    --help, -u             Print this message"<<endl;
#ifdef Jig
cout<<"    --jig                  Test component in temporary jig"<<endl;
#endif
cout<<"    --junk, -j folder      Add folder contents to junk mail dictionary"<<endl;
cout<<"    --list                 Print dictionary on standard output"<<endl;
cout<<"    --mail, -m folder      Add folder contents to legitimate mail dictionary"<<endl;
cout<<"    --newword n            Set probability for words not in dictionary to n"<<endl;
cout<<"    --pdiag fname          Print parser diagnostics to fname"<<endl;
cout<<"    --phraselimit n        Set phrase maximum length to n characters"<<endl;
cout<<"    --phrasemax n          Set phrase maximum to n words"<<endl;
cout<<"    --phrasemin n          Set phrase minimum to n words"<<endl;
#ifdef HAVE_PLOT_UTILITIES
cout<<"    --plot fname           Plot histogram of word probabilities in dictionary"<<endl;
#endif
cout<<"    --prune                Prune infrequently used words from dictionary"<<endl;
cout<<"    --ptrace               Include detailed trace in --pdiag output"<<endl;
cout<<"    --read, -r fname       Import dictionary from fname"<<endl;
cout<<"    --sigwords n           Classify message based on n most significant words"<<endl;
cout<<"    --statistics           Print statistics of dictionary"<<endl;
cout<<"    --test, -t fname       Test first message in fname"<<endl;
cout<<"    --threshjunk n         Set junk threshold to n"<<endl;
cout<<"    --threshmail n         Set mail threshold to n"<<endl;
cout<<"    --transcript fname     Write annotated message transcript to fname"<<endl;
cout<<"    --verbose, -v          Print processing information"<<endl;
cout<<"    --version              Print version number"<<endl;
cout<<"    --write fname          Export dictionary to fname"<<endl;
cout<<""<<endl;
cout<<"by John Walker"<<endl;
cout<<"http://www.fourmilab.ch/"<<endl;
}

/*:195*/
#line 7824 "annoyance-filter.w"

/*182:*/
#line 7045 "annoyance-filter.w"

static void addFolder(const char*fname,dictionaryWord::mailCategory cat)
{
if(verbose){
cerr<<"Adding folder "<<fname<<" as "<<
dictionaryWord::categoryName(cat)<<":"<<endl;
}

mailFolder mf(fname,cat);
tokenParser tp;

tp.setSource(mf);
tp.setTokenDefinition(isoToken,asciiToken);
tp.setTokenLengthLimits(maxTokenLength,minTokenLength,
streamMaxTokenLength,streamMinTokenLength);
if(pDiagFilename.length()> 0){
tp.setSaveMessage(true);
}
dictionaryWord dw;
unsigned int ntokens= 0;

while(tp.nextToken(dw)){
dict.add(dw,mf.getCategory());
ntokens++;
}
messageCount[mf.getCategory()]+= mf.getMessageCount();

if(verbose){
cerr<<"  Added "<<mf.getMessageCount()<<" messages, "<<
ntokens<<" tokens in "<<mf.getLineCount()<<" lines."<<endl;
cerr<<"  Dictionary contains "<<dict.size()<<" unique tokens."<<endl;
}
}

/*:182*/
#line 7825 "annoyance-filter.w"

/*178:*/
#line 7002 "annoyance-filter.w"


/*203:*/
#line 7800 "annoyance-filter.w"

#ifdef Jig
#endif

/*:203*/
#line 7004 "annoyance-filter.w"
;

int main(int argc,char*argv[])
{
int opt;

/*179:*/
#line 7018 "annoyance-filter.w"

memset(messageCount,0,sizeof messageCount);
isoToken.setISO_8859defaults(minTokenLength,maxTokenLength);
asciiToken.setUS_ASCIIdefaults(streamMinTokenLength,streamMaxTokenLength);

/*:179*/
#line 7010 "annoyance-filter.w"
;

/*196:*/
#line 7353 "annoyance-filter.w"



static const struct option long_options[]= {
{"annotate",1,NULL,222},
{"binword",1,NULL,221},
{"classify",1,NULL,209},
{"clearjunk",0,NULL,215},
{"clearmail",0,NULL,216},
{"copyright",0,NULL,200},
{"csvread",1,NULL,205},
{"csvwrite",1,NULL,207},
{"help",0,NULL,'u'},
#ifdef Jig
{"jig",0,NULL,206},
#endif
{"junk",1,NULL,'j'},
{"list",0,NULL,202},
{"mail",1,NULL,'m'},
{"newword",1,NULL,220},
{"pdiag",1,NULL,212},
{"phraselimit",1,NULL,224},
{"phrasemax",1,NULL,223},
{"phrasemin",1,NULL,217},
#ifdef HAVE_PLOT_UTILITIES
{"plot",1,NULL,211},
#endif
{"prune",0,NULL,203},
{"ptrace",0,NULL,213},
{"purge",0,NULL,203},
{"read",1,NULL,'r'},
{"sigwords",1,NULL,219},
{"statistics",0,NULL,210},
{"test",1,NULL,'t'},
{"threshjunk",1,NULL,208},
{"threshmail",1,NULL,214},
{"transcript",1,NULL,204},
{"verbose",0,NULL,'v'},
{"version",0,NULL,201},
{"write",1,NULL,218},
{0,0,0,0}
};
int option_index= 0;
bool lastOption= false;
int exitStatus= 0;

while((!lastOption)&&
(opt= getopt_long(argc,argv,"j:m:r:t:uv",long_options,&option_index))!=-1){

switch(opt){


case 222:
while((*optarg)!=0){
unsigned int ch= (*optarg++)&0xFF;

if(isascii(ch)&&isalpha(ch)&&isupper(ch)){
ch= islower(ch);
}
annotations.set(ch);
}
break;


case 221:
streamMinTokenLength= atoi(optarg);
if(verbose){
if(streamMinTokenLength> 0){
cerr<<"Binary streams will be parsed for words of "<<
streamMinTokenLength<<" characters or more."<<endl;
}else{
cerr<<"Binary streams will not be parsed for words."<<endl;
}
}
break;


case 209:
{
if(optind<argc){
cerr<<"Warning: command line arguments after \"--classify "<<
optarg<<" will be ignored."<<endl;
}
double score= classifyMessages(optarg);

if(score>=junkThreshold){
cout<<"JUNK"<<endl;
exitStatus= 3;
}else if(score<=mailThreshold){
cout<<"MAIL"<<endl;
exitStatus= 0;
}else{
cout<<"INDT"<<endl;
exitStatus= 4;
}
lastOption= true;
break;
}


case 215:
dict.resetCat(dictionaryWord::Junk);
messageCount[dictionaryWord::Junk]= 0;
break;


case 216:
dict.resetCat(dictionaryWord::Mail);
messageCount[dictionaryWord::Mail]= 0;
break;


case 200:
cout<<"This program is in the public domain.\n";
return 0;


case 205:
{ifstream is(optarg);
if(!is){
cerr<<"Cannot open CSV dictionary file "<<optarg<<endl;
return 1;
}
dict.importCSV(is);
if(!singleDictionaryRead){
updateProbability();
}
singleDictionaryRead= false;
is.close();
}
break;


case 207:
{ofstream of(optarg);
if(!of){
cerr<<"Cannot create CSV export file "<<optarg<<endl;
return 1;
}
updateProbability();
dict.exportCSV(of);
of.close();
}
break;


case'u':
case'?':
usage();
return 0;

#ifdef Jig

case 206:
{
/*202:*/
#line 7791 "annoyance-filter.w"

#ifdef Jig
#endif

/*:202*/
#line 7508 "annoyance-filter.w"
;
}
break;
#endif


case'j':
addFolder(optarg,dictionaryWord::Junk);
updateProbability();
break;


case 202:
printDictionary();
break;


case'm':
addFolder(optarg,dictionaryWord::Mail);
updateProbability();
break;


case 220:
novelWordProbability= atof(optarg);
if(verbose){
cerr<<"Probability for words not in dictionary set to "<<novelWordProbability<<"."<<endl;
}
break;


case 212:
pDiagFilename= optarg;
break;


case 224:
phraseLimit= atoi(optarg);
if(verbose){
cerr<<"Phrase maximum length set to "<<phraseLimit<<" characters."<<endl;
}
break;


case 223:
phraseMax= atoi(optarg);
if(verbose){
cerr<<"Phrase maximum length set to "<<phraseMax<<" word"<<
(phraseMax==1?"":"s")<<"."<<endl;
}
break;


case 217:
phraseMin= atoi(optarg);
if(verbose){
cerr<<"Phrase minimum length set to "<<phraseMin<<" word"<<
(phraseMin==1?"":"s")<<"."<<endl;
}
break;


#ifdef HAVE_PLOT_UTILITIES
case 211:
updateProbability();
dict.plotProbabilityHistogram(optarg);
break;
#endif


case 203:
updateProbability();
dict.purge();
break;


case 213:
pTokenTrace= true;
break;


case'r':
{
#ifdef HAVE_MMAP
int fileHandle= open(optarg,O_RDONLY);
if(fileHandle==-1){
cerr<<"Cannot open dictionary file "<<optarg<<endl;
return 1;
}
long fileLength= lseek(fileHandle,0,2);
lseek(fileHandle,0,0);
char*dp= static_cast<char*> (mmap((caddr_t)0,fileLength,
PROT_READ,MAP_SHARED|MAP_NORESERVE,
fileHandle,0));
istrstream is(dp,fileLength);
#else
ifstream is(optarg,ios::binary);
if(!is){
cerr<<"Cannot open dictionary file "<<optarg<<endl;
return 1;
}
#endif
dict.importFromBinaryFile(is);
#ifdef HAVE_MMAP
munmap(dp,fileLength);
close(fileHandle);
#else
is.close();
#endif
if(!singleDictionaryRead){
updateProbability();
}
singleDictionaryRead= false;
}
break;


case 219:
significantWords= atoi(optarg);
if(verbose){
cerr<<"Significant words set to "<<significantWords<<"."<<endl;
}
break;


case 210:
updateProbability();
dict.printStatistics();
break;


case't':
{double score= classifyMessages(optarg);

if(transcriptFilename!="-"){
cout<<"Junk probability "<<score<<endl;
}
}
break;


case 208:
junkThreshold= atof(optarg);
if(verbose){
cerr<<"Junk threshold set to "<<setprecision(5)<<junkThreshold<<"."<<endl;
}
break;


case 214:
mailThreshold= atof(optarg);
if(verbose){
cerr<<"Mail threshold set to "<<setprecision(5)<<mailThreshold<<"."<<endl;
}
break;


case 204:
transcriptFilename= optarg;
break;


case'v':
verbose= true;
break;


case 201:
cout<<PRODUCT" "VERSION<<endl;
cout<<"Last revised: "REVDATE<<endl;
cout<<"The latest version is always available from:"<<endl;
cout<<"    http://www.fourmilab.ch/annoyance-filter/"<<endl;
cout<<"Please report bugs to:"<<endl;
cout<<"    bugs@fourmilab.ch"<<endl;
return 0;


case 218:
{ofstream of(optarg,ios::binary);
if(!of){
cerr<<"Cannot create dictionary file "<<optarg<<endl;
return 1;
}
updateProbability();
dict.exportToBinaryFile(of);
of.close();
}
break;


default:
cerr<<"***Internal error: unhandled case "<<opt<<
" in option processing."<<endl;
return 1;
}
}

/*197:*/
#line 7713 "annoyance-filter.w"

if(pTokenTrace&&(pDiagFilename=="")){
cerr<<"Warning: --ptrace requested but no --pdiag file specified."<<endl;
}

if((transcriptFilename!="")&&(nTested==0)){
cerr<<"Warning: --transcript requested but no message --test or --classify done."<<endl;
}

if((pDiagFilename!="")&&(nTested==0)){
cerr<<"Warning: --pdiag requested but no message --test or --classify done."<<endl;
}

if(annotations.count()> 0&&(transcriptFilename=="")){
cerr<<"Warning: --annotate requested but no --transcript file specified."<<endl;
}

/*:197*/
#line 7705 "annoyance-filter.w"
;

/*:196*/
#line 7012 "annoyance-filter.w"
;

return exitStatus;
}

/*:178*/
#line 7826 "annoyance-filter.w"




#line 1 "log.w"

/*:204*/
